"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDynamicRoute = exports.resolveDynamicPagesToRewrites = exports.getNextExportedFunctions = exports.getNextPageInfos = exports.isDynamicPage = exports.recursiveReadDir = void 0;
const babel = __importStar(require("@babel/core"));
const fs = __importStar(require("fs"));
const constants_1 = require("../constants");
const isDynamicPage_1 = require("./isDynamicPage");
var recursiveReadDir_1 = require("./recursiveReadDir");
Object.defineProperty(exports, "recursiveReadDir", { enumerable: true, get: function () { return recursiveReadDir_1.recursiveReadDir; } });
var isDynamicPage_2 = require("./isDynamicPage");
Object.defineProperty(exports, "isDynamicPage", { enumerable: true, get: function () { return isDynamicPage_2.isDynamicPage; } });
var getNextPageInfos_1 = require("./getNextPageInfos");
Object.defineProperty(exports, "getNextPageInfos", { enumerable: true, get: function () { return getNextPageInfos_1.getNextPageInfos; } });
const NEXT_EXPORT_FUNCTIONS = [
    'getStaticProps',
    'getStaticPaths',
    'getServerSideProps'
];
function getNextExportedFunctions(filename) {
    const code = fs.readFileSync(filename, 'utf-8');
    const ast = babel.parseSync(code, { filename });
    const result = [];
    babel.traverse(ast, {
        ExportNamedDeclaration(path) {
            const specifiers = path.get('specifiers');
            if (specifiers && specifiers.length) {
                for (const specifier of specifiers) {
                    const exported = specifier.node.exported;
                    if (exported.type === 'Identifier' && NEXT_EXPORT_FUNCTIONS.includes(exported.name)) {
                        result.push(exported.name);
                    }
                }
            }
            const declaration = path.get('declaration');
            if (declaration && declaration.node) {
                if (declaration.isFunctionDeclaration()) {
                    const name = declaration.node.id.name;
                    if (NEXT_EXPORT_FUNCTIONS.includes(name)) {
                        result.push(name);
                    }
                }
                if (declaration.isVariableDeclaration()) {
                    for (const declarator of declaration.node.declarations) {
                        if (declarator.id.type !== 'Identifier') {
                            return;
                        }
                        const name = declarator.id.name;
                        if (NEXT_EXPORT_FUNCTIONS.includes(name)) {
                            result.push(name);
                        }
                    }
                }
            }
        }
    });
    return result;
}
exports.getNextExportedFunctions = getNextExportedFunctions;
function resolveDynamicPagesToRewrites(dynamicPages) {
    const rewrites = dynamicPages.map(page => {
        const segments = page.split('/').filter(Boolean);
        let source = '';
        let destination = '';
        const has = [];
        for (let i = 0; i < segments.length; i++) {
            const segment = segments[i];
            if ((0, isDynamicPage_1.isDynamicPage)(segment)) {
                const key = segment.substring(1, segment.length - 1);
                if (key) {
                    has.push({
                        type: 'query',
                        key,
                        value: `(?<${key}>.*)`
                    });
                    destination += `/:${key}`;
                }
            }
            else if (has.length === 0) {
                source += `/${segment}`;
                destination += `/${segment}`;
            }
            else if (segment !== 'index' || i !== segments.length - 1) {
                return null;
            }
        }
        return {
            source,
            has,
            destination
        };
    });
    return rewrites.filter(Boolean);
}
exports.resolveDynamicPagesToRewrites = resolveDynamicPagesToRewrites;
// Identify /[param]/ in route string
const TEST_ROUTE_PATTERN = `\\[[^/]+?\\](${constants_1.SCRIPT_EXTS.join('|')})$`;
function isDynamicRoute(route) {
    return new RegExp(TEST_ROUTE_PATTERN).test(route);
}
exports.isDynamicRoute = isDynamicRoute;
