"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const scss_bundle_1 = require("scss-bundle");
/**
 * Return bundled sass content.
 */
function getBundleResult(url, projectDirectory) {
    return __awaiter(this, void 0, void 0, function* () {
        let bundler = new scss_bundle_1.Bundler();
        if (projectDirectory) {
            bundler = new scss_bundle_1.Bundler(undefined, projectDirectory);
        }
        const res = yield bundler.bundle(url);
        return res;
    });
}
/**
 * Return bundled sass content, but input resource can be a single string or an array.
 */
function getBundleContent(resource, projectDirectory) {
    return __awaiter(this, void 0, void 0, function* () {
        let result = '';
        if (typeof resource === 'string') {
            const res = yield getBundleResult(resource, projectDirectory);
            result = res.bundledContent || '';
        }
        else if (Array.isArray(resource)) {
            for (const url of resource) {
                const res = yield getBundleResult(url, projectDirectory);
                result += res.bundledContent || '';
            }
        }
        return result;
    });
}
/**
 * Check if global imported sass file exists.
 */
function checkPath(resource, rootDir) {
    if (Array.isArray(resource)) {
        resource.forEach(item => {
            const url = rootDir ? path.resolve(rootDir, item) : item;
            if (!fs.existsSync(url)) {
                throw new Error(`全局注入 scss 文件路径错误: ${url}`);
            }
        });
    }
    else if (typeof resource === 'string') {
        const url = rootDir ? path.resolve(rootDir, resource) : resource;
        if (!fs.existsSync(url)) {
            throw new Error(`全局注入 scss 文件路径错误: ${url}`);
        }
    }
}
/**
 * Return the merged sass options.
 */
function getNextSassOptions(sass) {
    return __awaiter(this, void 0, void 0, function* () {
        const { data, resource, projectDirectory } = sass;
        let additionalData = '';
        if (resource) {
            checkPath(resource, projectDirectory);
            const content = yield getBundleContent(resource, projectDirectory);
            additionalData += content;
        }
        if (data) {
            additionalData += data;
        }
        return additionalData;
    });
}
exports.default = getNextSassOptions;
