"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeTaroPages = void 0;
const utils_1 = require("../utils");
function mergeTaroPages(pages, subPackages) {
    const taroPages = [];
    if (Array.isArray(pages)) {
        for (const page of pages) {
            taroPages.push((0, utils_1.ensureLeadingSlash)(page));
        }
    }
    if (Array.isArray(subPackages)) {
        for (const pkg of subPackages) {
            if (Array.isArray(pkg.pages)) {
                for (const page of pkg.pages) {
                    taroPages.push((0, utils_1.ensureLeadingSlash)(`${pkg.root}/${page}`));
                }
            }
        }
    }
    return taroPages;
}
exports.mergeTaroPages = mergeTaroPages;
