"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  canIUse: true,
  arrayBufferToBase64: true,
  base64ToArrayBuffer: true
};
exports.canIUse = exports.base64ToArrayBuffer = exports.arrayBufferToBase64 = void 0;

var _base64Js = require("base64-js");

var _util = require("../_util");

var _system = require("./system");

Object.keys(_system).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _system[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _system[key];
    }
  });
});

var _update = require("./update");

Object.keys(_update).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _update[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _update[key];
    }
  });
});

var _debug = require("./debug");

Object.keys(_debug).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _debug[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _debug[key];
    }
  });
});

var _performance = require("./performance");

Object.keys(_performance).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _performance[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _performance[key];
    }
  });
});

/**
 * 判断智能小程序的 API ，回调，参数，组件等是否在当前版本和当前系统下可用。
 */
var canIUse = _util.unsupported.never('canIUse');
/**
 * 将 ArrayBuffer 对象转成 Base64 字符串
 */


exports.canIUse = canIUse;
var arrayBufferToBase64 = _base64Js.fromByteArray;
/**
 * 将 Base64 字符串转成 ArrayBuffer 对象
 */

exports.arrayBufferToBase64 = arrayBufferToBase64;
var base64ToArrayBuffer = _base64Js.toByteArray;
exports.base64ToArrayBuffer = base64ToArrayBuffer;