"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CanvasContext = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _createForOfIteratorHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/createForOfIteratorHelper"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var TextBaseLineMap = {
  top: 'top',
  bottom: 'bottom',
  middle: 'middle',
  normal: 'alphabetic'
};

var CanvasContext = /*#__PURE__*/function () {
  function CanvasContext(canvas, ctx) {
    (0, _classCallCheck2.default)(this, CanvasContext);
    (0, _defineProperty2.default)(this, "actions", []);
    this.canvas = canvas;
    this.ctx = ctx;
  }

  (0, _createClass2.default)(CanvasContext, [{
    key: "ctx",
    get: function get() {
      return this.__raw__ || {};
    },
    set: function set(e) {
      this.__raw__ = e;
    }
  }, {
    key: "emptyActions",
    value: function emptyActions() {
      this.actions.length = 0;
    }
  }, {
    key: "enqueueActions",
    value: function enqueueActions(func) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      this.actions.push({
        func: func,
        args: args
      });
    }
  }, {
    key: "fillStyle",
    get: function get() {
      return this.ctx.fillStyle;
    },
    set: function set(e) {
      var _this = this;

      this.enqueueActions(function () {
        _this.ctx.fillStyle = e;
      });
    }
  }, {
    key: "font",
    get: function get() {
      return this.ctx.font;
    },
    set: function set(e) {
      this.ctx.font = e;
    }
  }, {
    key: "globalAlpha",
    get: function get() {
      return this.ctx.globalAlpha;
    },
    set: function set(e) {
      var _this2 = this;

      this.enqueueActions(function () {
        _this2.ctx.globalAlpha = e;
      });
    }
  }, {
    key: "globalCompositeOperation",
    get: function get() {
      return this.ctx.globalCompositeOperation;
    },
    set: function set(e) {
      var _this3 = this;

      this.enqueueActions(function () {
        _this3.ctx.globalCompositeOperation = e;
      });
    }
  }, {
    key: "lineCap",
    get: function get() {
      return this.ctx.lineCap;
    },
    set: function set(e) {
      var _this4 = this;

      this.enqueueActions(function () {
        _this4.ctx.lineCap = e;
      });
    }
  }, {
    key: "lineDashOffset",
    get: function get() {
      return this.ctx.lineDashOffset;
    },
    set: function set(e) {
      var _this5 = this;

      this.enqueueActions(function () {
        _this5.ctx.lineDashOffset = e;
      });
    }
  }, {
    key: "lineJoin",
    get: function get() {
      return this.ctx.lineJoin;
    },
    set: function set(e) {
      var _this6 = this;

      this.enqueueActions(function () {
        _this6.ctx.lineJoin = e;
      });
    }
  }, {
    key: "lineWidth",
    get: function get() {
      return this.ctx.lineWidth;
    },
    set: function set(e) {
      var _this7 = this;

      this.enqueueActions(function () {
        _this7.ctx.lineWidth = e;
      });
    }
  }, {
    key: "miterLimit",
    get: function get() {
      return this.ctx.miterLimit;
    },
    set: function set(e) {
      var _this8 = this;

      this.enqueueActions(function () {
        _this8.ctx.miterLimit = e;
      });
    }
  }, {
    key: "shadowBlur",
    get: function get() {
      return this.ctx.shadowBlur;
    },
    set: function set(e) {
      var _this9 = this;

      this.enqueueActions(function () {
        _this9.ctx.shadowBlur = e;
      });
    }
  }, {
    key: "shadowColor",
    get: function get() {
      return this.ctx.shadowColor;
    },
    set: function set(e) {
      var _this10 = this;

      this.enqueueActions(function () {
        _this10.ctx.shadowColor = e;
      });
    }
  }, {
    key: "shadowOffsetX",
    get: function get() {
      return this.ctx.shadowOffsetX;
    },
    set: function set(e) {
      var _this11 = this;

      this.enqueueActions(function () {
        _this11.ctx.shadowOffsetX = e;
      });
    }
  }, {
    key: "shadowOffsetY",
    get: function get() {
      return this.ctx.shadowOffsetY;
    },
    set: function set(e) {
      var _this12 = this;

      this.enqueueActions(function () {
        _this12.ctx.shadowOffsetY = e;
      });
    }
  }, {
    key: "strokeStyle",
    get: function get() {
      return this.ctx.strokeStyle;
    }
    /** 小程序文档中不包括 ↓↓↓ */
    ,
    set: function set(e) {
      var _this13 = this;

      this.enqueueActions(function () {
        _this13.ctx.strokeStyle = e;
      });
    }
  }, {
    key: "textAlign",
    get: function get() {
      return this.ctx.textAlign;
    },
    set: function set(e) {
      this.ctx.textAlign = e;
    }
  }, {
    key: "textBaseline",
    get: function get() {
      return this.ctx.textBaseline;
    },
    set: function set(e) {
      this.ctx.textBaseline = e;
    }
  }, {
    key: "direction",
    get: function get() {
      return this.ctx.direction;
    },
    set: function set(e) {
      this.ctx.direction = e;
    }
  }, {
    key: "imageSmoothingEnabled",
    get: function get() {
      return this.ctx.imageSmoothingEnabled;
    },
    set: function set(e) {
      var _this14 = this;

      this.enqueueActions(function () {
        _this14.ctx.imageSmoothingEnabled = e;
      });
    }
  }, {
    key: "imageSmoothingQuality",
    get: function get() {
      return this.ctx.imageSmoothingQuality;
    },
    set: function set(e) {
      var _this15 = this;

      this.enqueueActions(function () {
        _this15.ctx.imageSmoothingQuality = e;
      });
    }
  }, {
    key: "filter",
    get: function get() {
      return this.ctx.filter;
    }
    /** 小程序文档中不包括 ↑↑↑ */
    ,
    set: function set(e) {
      var _this16 = this;

      this.enqueueActions(function () {
        _this16.ctx.filter = e;
      });
    }
  }, {
    key: "arc",
    value: function arc() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return this.enqueueActions.apply(this, [this.ctx.arc].concat(args));
    }
  }, {
    key: "arcTo",
    value: function arcTo() {
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return this.enqueueActions.apply(this, [this.ctx.arcTo].concat(args));
    }
  }, {
    key: "beginPath",
    value: function beginPath() {
      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return this.enqueueActions.apply(this, [this.ctx.beginPath].concat(args));
    }
  }, {
    key: "bezierCurveTo",
    value: function bezierCurveTo() {
      for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      return this.enqueueActions.apply(this, [this.ctx.bezierCurveTo].concat(args));
    }
  }, {
    key: "clearRect",
    value: function clearRect() {
      for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
        args[_key6] = arguments[_key6];
      }

      return this.enqueueActions.apply(this, [this.ctx.clearRect].concat(args));
    }
  }, {
    key: "clip",
    value: function clip() {
      for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
        args[_key7] = arguments[_key7];
      }

      return this.enqueueActions.apply(this, [this.ctx.clip].concat(args));
    }
  }, {
    key: "closePath",
    value: function closePath() {
      for (var _len8 = arguments.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
        args[_key8] = arguments[_key8];
      }

      return this.enqueueActions.apply(this, [this.ctx.closePath].concat(args));
    }
  }, {
    key: "createPattern",
    value: function createPattern(image, repetition) {
      return this.createPattern(image, repetition);
    }
    /**
     * 将之前在绘图上下文中的描述（路径、变形、样式）画到 canvas 中。
     * @todo 每次 draw 都会读取 width 和 height
     */

  }, {
    key: "draw",
    value: function () {
      var _draw = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(reserve, callback) {
        var _iterator, _step, _step$value, _func, _args, _iterator2, _step2, _step2$value, func, args;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!reserve) {
                  this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
                } // 部分 action 是异步的


                _iterator = (0, _createForOfIteratorHelper2.default)(this.actions);
                _context.prev = 2;

                _iterator.s();

              case 4:
                if ((_step = _iterator.n()).done) {
                  _context.next = 10;
                  break;
                }

                _step$value = _step.value, _func = _step$value.func, _args = _step$value.args;
                _context.next = 8;
                return _func.apply(this.ctx, _args);

              case 8:
                _context.next = 4;
                break;

              case 10:
                _context.next = 15;
                break;

              case 12:
                _context.prev = 12;
                _context.t0 = _context["catch"](2);

                _iterator.e(_context.t0);

              case 15:
                _context.prev = 15;

                _iterator.f();

                return _context.finish(15);

              case 18:
                this.emptyActions();
                callback && callback();
                _context.prev = 20;

                if (!reserve) {
                  this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
                } // 部分 action 是异步的


                _iterator2 = (0, _createForOfIteratorHelper2.default)(this.actions);
                _context.prev = 23;

                _iterator2.s();

              case 25:
                if ((_step2 = _iterator2.n()).done) {
                  _context.next = 31;
                  break;
                }

                _step2$value = _step2.value, func = _step2$value.func, args = _step2$value.args;
                _context.next = 29;
                return func.apply(this.ctx, args);

              case 29:
                _context.next = 25;
                break;

              case 31:
                _context.next = 36;
                break;

              case 33:
                _context.prev = 33;
                _context.t1 = _context["catch"](23);

                _iterator2.e(_context.t1);

              case 36:
                _context.prev = 36;

                _iterator2.f();

                return _context.finish(36);

              case 39:
                this.emptyActions();
                callback && callback();
                _context.next = 46;
                break;

              case 43:
                _context.prev = 43;
                _context.t2 = _context["catch"](20);
                throw {
                  errMsg: _context.t2.message
                };

              case 46:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 12, 15, 18], [20, 43], [23, 33, 36, 39]]);
      }));

      function draw(_x, _x2) {
        return _draw.apply(this, arguments);
      }

      return draw;
    }()
  }, {
    key: "drawImage",
    value: function drawImage(imageResource) {
      var _this17 = this;

      for (var _len9 = arguments.length, extra = new Array(_len9 > 1 ? _len9 - 1 : 0), _key9 = 1; _key9 < _len9; _key9++) {
        extra[_key9 - 1] = arguments[_key9];
      }

      this.enqueueActions(function () {
        var _this17$ctx2;

        // 需要转换为 Image
        if (typeof imageResource === 'string') {
          var img = new Image();
          img.src = imageResource;
          return new Promise(function (resolve, reject) {
            img.onload = function () {
              var _this17$ctx;

              (_this17$ctx = _this17.ctx).drawImage.apply(_this17$ctx, [img].concat((0, _toConsumableArray2.default)(extra)));

              resolve();
            };

            img.onerror = reject;
          });
        }

        (_this17$ctx2 = _this17.ctx).drawImage.apply(_this17$ctx2, [imageResource].concat((0, _toConsumableArray2.default)(extra)));
      });
    }
  }, {
    key: "fill",
    value: function fill() {
      for (var _len10 = arguments.length, args = new Array(_len10), _key10 = 0; _key10 < _len10; _key10++) {
        args[_key10] = arguments[_key10];
      }

      return this.enqueueActions.apply(this, [this.ctx.fill].concat(args));
    }
  }, {
    key: "fillRect",
    value: function fillRect() {
      for (var _len11 = arguments.length, args = new Array(_len11), _key11 = 0; _key11 < _len11; _key11++) {
        args[_key11] = arguments[_key11];
      }

      return this.enqueueActions.apply(this, [this.ctx.fillRect].concat(args));
    }
  }, {
    key: "fillText",
    value: function fillText() {
      for (var _len12 = arguments.length, args = new Array(_len12), _key12 = 0; _key12 < _len12; _key12++) {
        args[_key12] = arguments[_key12];
      }

      return this.enqueueActions.apply(this, [this.ctx.fillText].concat(args));
    }
  }, {
    key: "lineTo",
    value: function lineTo() {
      for (var _len13 = arguments.length, args = new Array(_len13), _key13 = 0; _key13 < _len13; _key13++) {
        args[_key13] = arguments[_key13];
      }

      return this.enqueueActions.apply(this, [this.ctx.lineTo].concat(args));
    }
  }, {
    key: "moveTo",
    value: function moveTo() {
      for (var _len14 = arguments.length, args = new Array(_len14), _key14 = 0; _key14 < _len14; _key14++) {
        args[_key14] = arguments[_key14];
      }

      return this.enqueueActions.apply(this, [this.ctx.moveTo].concat(args));
    }
  }, {
    key: "quadraticCurveTo",
    value: function quadraticCurveTo() {
      for (var _len15 = arguments.length, args = new Array(_len15), _key15 = 0; _key15 < _len15; _key15++) {
        args[_key15] = arguments[_key15];
      }

      return this.enqueueActions.apply(this, [this.ctx.quadraticCurveTo].concat(args));
    }
  }, {
    key: "rect",
    value: function rect() {
      for (var _len16 = arguments.length, args = new Array(_len16), _key16 = 0; _key16 < _len16; _key16++) {
        args[_key16] = arguments[_key16];
      }

      return this.enqueueActions.apply(this, [this.ctx.rect].concat(args));
    }
  }, {
    key: "restore",
    value: function restore() {
      for (var _len17 = arguments.length, args = new Array(_len17), _key17 = 0; _key17 < _len17; _key17++) {
        args[_key17] = arguments[_key17];
      }

      return this.enqueueActions.apply(this, [this.ctx.restore].concat(args));
    }
  }, {
    key: "rotate",
    value: function rotate() {
      for (var _len18 = arguments.length, args = new Array(_len18), _key18 = 0; _key18 < _len18; _key18++) {
        args[_key18] = arguments[_key18];
      }

      return this.enqueueActions.apply(this, [this.ctx.rotate].concat(args));
    }
  }, {
    key: "save",
    value: function save() {
      for (var _len19 = arguments.length, args = new Array(_len19), _key19 = 0; _key19 < _len19; _key19++) {
        args[_key19] = arguments[_key19];
      }

      return this.enqueueActions.apply(this, [this.ctx.save].concat(args));
    }
  }, {
    key: "scale",
    value: function scale() {
      for (var _len20 = arguments.length, args = new Array(_len20), _key20 = 0; _key20 < _len20; _key20++) {
        args[_key20] = arguments[_key20];
      }

      return this.enqueueActions.apply(this, [this.ctx.scale].concat(args));
    }
  }, {
    key: "setFillStyle",
    value: function setFillStyle(color) {
      var _this18 = this;

      this.enqueueActions(function () {
        _this18.ctx.fillStyle = color;
      });
    }
  }, {
    key: "setFontSize",
    value: function setFontSize(fontSize) {
      this.font = "".concat(fontSize, "px");
    }
  }, {
    key: "setGlobalAlpha",
    value: function setGlobalAlpha(alpha) {
      this.globalAlpha = alpha;
    }
  }, {
    key: "setLineCap",
    value: function setLineCap(lineCap) {
      this.lineCap = lineCap;
    }
  }, {
    key: "setLineDash",
    value: function setLineDash(pattern, offset) {
      var _this19 = this;

      this.enqueueActions(function () {
        _this19.ctx.setLineDash(pattern);

        _this19.ctx.lineDashOffset = offset;
      });
    }
  }, {
    key: "setLineJoin",
    value: function setLineJoin(lineJoin) {
      this.lineJoin = lineJoin;
    }
  }, {
    key: "setLineWidth",
    value: function setLineWidth(lineWidth) {
      this.lineWidth = lineWidth;
    }
  }, {
    key: "setMiterLimit",
    value: function setMiterLimit(miterLimit) {
      this.miterLimit = miterLimit;
    }
  }, {
    key: "setShadow",
    value: function setShadow(offsetX, offsetY, blur, color) {
      var _this20 = this;

      this.enqueueActions(function () {
        _this20.ctx.shadowOffsetX = offsetX;
        _this20.ctx.shadowOffsetY = offsetY;
        _this20.ctx.shadowColor = color;
        _this20.ctx.shadowBlur = blur;
      });
    }
  }, {
    key: "setStrokeStyle",
    value: function setStrokeStyle(color) {
      var _this21 = this;

      this.enqueueActions(function () {
        _this21.ctx.strokeStyle = color;
      });
    }
  }, {
    key: "setTextAlign",
    value: function setTextAlign(align) {
      this.textAlign = align;
    }
  }, {
    key: "setTextBaseline",
    value: function setTextBaseline(textBaseline) {
      this.textBaseline = TextBaseLineMap[textBaseline] || 'alphabetic';
    }
  }, {
    key: "setTransform",
    value: function setTransform() {
      for (var _len21 = arguments.length, args = new Array(_len21), _key21 = 0; _key21 < _len21; _key21++) {
        args[_key21] = arguments[_key21];
      }

      return this.enqueueActions.apply(this, [this.ctx.setTransform].concat(args));
    }
  }, {
    key: "stroke",
    value: function stroke() {
      for (var _len22 = arguments.length, args = new Array(_len22), _key22 = 0; _key22 < _len22; _key22++) {
        args[_key22] = arguments[_key22];
      }

      return this.enqueueActions.apply(this, [this.ctx.stroke].concat(args));
    }
  }, {
    key: "strokeRect",
    value: function strokeRect() {
      for (var _len23 = arguments.length, args = new Array(_len23), _key23 = 0; _key23 < _len23; _key23++) {
        args[_key23] = arguments[_key23];
      }

      return this.enqueueActions.apply(this, [this.ctx.strokeRect].concat(args));
    }
  }, {
    key: "strokeText",
    value: function strokeText() {
      for (var _len24 = arguments.length, args = new Array(_len24), _key24 = 0; _key24 < _len24; _key24++) {
        args[_key24] = arguments[_key24];
      }

      return this.enqueueActions.apply(this, [this.ctx.strokeText].concat(args));
    }
  }, {
    key: "transform",
    value: function transform() {
      for (var _len25 = arguments.length, args = new Array(_len25), _key25 = 0; _key25 < _len25; _key25++) {
        args[_key25] = arguments[_key25];
      }

      return this.enqueueActions.apply(this, [this.ctx.transform].concat(args));
    }
  }, {
    key: "translate",
    value: function translate() {
      for (var _len26 = arguments.length, args = new Array(_len26), _key26 = 0; _key26 < _len26; _key26++) {
        args[_key26] = arguments[_key26];
      }

      return this.enqueueActions.apply(this, [this.ctx.translate].concat(args));
    }
  }, {
    key: "measureText",
    value: function measureText(text) {
      return this.ctx.measureText(text);
    }
  }, {
    key: "createCircularGradient",
    value: function createCircularGradient(x, y, r) {
      var radialGradient = this.ctx.createRadialGradient(x, y, 0, x, y, r);
      return radialGradient;
    }
  }, {
    key: "createLinearGradient",
    value: function createLinearGradient(x0, y0, x1, y1) {
      return this.createLinearGradient(x0, y0, x1, y1);
    }
  }]);
  return CanvasContext;
}();

exports.CanvasContext = CanvasContext;