"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.canvasGetImageData = void 0;

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

var canvasGetImageDataInternal = function canvasGetImageDataInternal(_ref) {
  var canvasId = _ref.canvasId,
      success = _ref.success,
      fail = _ref.fail,
      complete = _ref.complete,
      x = _ref.x,
      y = _ref.y,
      width = _ref.width,
      height = _ref.height;

  if (typeof canvasId !== 'string') {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: 'The canvasId param is required.'
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  var canvas = document.querySelector("canvas[canvas-id=\"".concat(canvasId, "\"]"));

  if (!canvas) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: "Cannot find canvas by using canvasId: ".concat(canvasId, ".")
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  var ctx = canvas.getContext('2d');

  if (!ctx) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: 'Your browser does not support canvas api.'
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  try {
    var imageData = ctx.getImageData(x, y, width, height);
    success === null || success === void 0 ? void 0 : success({
      width: width,
      height: height,
      data: imageData.data
    });
  } catch (err) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: err.message
    });
  }

  complete === null || complete === void 0 ? void 0 : complete();
};
/**
 * 获取 canvas 区域隐含的像素数据。
 */


var canvasGetImageData = (0, _mpromisify.default)(_util.limited.async('canvasGetImageData', canvasGetImageDataInternal));
exports.canvasGetImageData = canvasGetImageData;