"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.canvasPutImageData = void 0;

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

var canvasPutImageDataInternal = function canvasPutImageDataInternal(_ref) {
  var canvasId = _ref.canvasId,
      data = _ref.data,
      x = _ref.x,
      y = _ref.y,
      width = _ref.width,
      height = _ref.height,
      success = _ref.success,
      fail = _ref.fail,
      complete = _ref.complete;

  if (typeof canvasId !== 'string') {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: 'The canvasId param is required.'
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  var canvas = document.querySelector("canvas[canvas-id=\"".concat(canvasId, "\"]"));

  if (!canvas) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: "Cannot find canvas by using canvasId: ".concat(canvasId, ".")
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  var ctx = canvas.getContext('2d');

  if (!ctx) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: 'Your browser does not support canvas api.'
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  try {
    var imageData = new ImageData(data, width, height);
    ctx.putImageData(imageData, x, y);
    success === null || success === void 0 ? void 0 : success();
  } catch (err) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: err.message
    });
  }

  complete === null || complete === void 0 ? void 0 : complete();
};
/**
 * 将像素数据绘制到画布。在自定义组件下，第二个参数传入自定义组件实例 this，以操作组件内 <canvas> 组件
 */


var canvasPutImageData = (0, _mpromisify.default)(_util.limited.async('canvasPutImageData', canvasPutImageDataInternal));
exports.canvasPutImageData = canvasPutImageData;