"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.canvasToTempFilePath = void 0;

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

var canvasToTempFilePathInternal = function canvasToTempFilePathInternal(_ref) {
  var canvasId = _ref.canvasId,
      fileType = _ref.fileType,
      quality = _ref.quality,
      success = _ref.success,
      fail = _ref.fail,
      complete = _ref.complete;

  if (typeof canvasId !== 'string') {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: 'The canvasId param is required.'
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  var canvas = document.querySelector("canvas[canvas-id=\"".concat(canvasId, "\"]"));

  if (!canvas) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: "Cannot find canvas by using canvasId: ".concat(canvasId, ".")
    });
    complete === null || complete === void 0 ? void 0 : complete();
    return;
  }

  try {
    var dataURL = canvas.toDataURL("image/".concat(fileType || 'png'), quality);
    success === null || success === void 0 ? void 0 : success({
      tempFilePath: dataURL
    });
  } catch (err) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: err.message
    });
  }

  complete === null || complete === void 0 ? void 0 : complete();
};
/**
 * 把当前画布指定区域的内容导出生成指定大小的图片。在 draw() 回调里调用该方法才能保证图片导出成功。
 * @todo 暂未支持尺寸相关功能
 */


var canvasToTempFilePath = (0, _mpromisify.default)(_util.limited.async('canvasToTempFilePath', canvasToTempFilePathInternal));
exports.canvasToTempFilePath = canvasToTempFilePath;