"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createCanvasContext = void 0;

var _util = require("../_util");

var _CanvasContext = require("./CanvasContext");

/**
 * 创建 canvas 的绘图上下文 CanvasContext 对象
 */
var createCanvasContext = function createCanvasContext(canvasId, inst) {
  var el = (0, _util.findDOM)(inst);
  var canvas = el === null || el === void 0 ? void 0 : el.querySelector("canvas[canvas-id=\"".concat(canvasId, "\"]"));
  var ctx = canvas === null || canvas === void 0 ? void 0 : canvas.getContext('2d');
  var context = new _CanvasContext.CanvasContext(canvas, ctx);
  if (!ctx) return context;
  context.canvas = canvas;
  context.ctx = ctx;
  return context;
};

exports.createCanvasContext = createCanvasContext;