"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBatteryInfoSync = exports.getBatteryInfo = void 0;

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

/**
 * getBatteryInfo 的同步版本。
 */
var getBatteryInfoSync = _util.unsupported.never('getBatteryInfoSync');

exports.getBatteryInfoSync = getBatteryInfoSync;

var getBatteryInfoInternal = function getBatteryInfoInternal(_ref) {
  var success = _ref.success,
      fail = _ref.fail,
      complete = _ref.complete;

  if (!('getBattery' in navigator)) {
    var err = {
      errMsg: 'Your browser does not support getting battery info.'
    };
    fail === null || fail === void 0 ? void 0 : fail(err);
    complete === null || complete === void 0 ? void 0 : complete();
  } else {
    navigator.getBattery().then(function (_ref2) {
      var charging = _ref2.charging,
          level = _ref2.level;
      success === null || success === void 0 ? void 0 : success({
        isCharging: charging,
        level: Number(level || 0) * 100
      });
    }).catch(function (err) {
      fail === null || fail === void 0 ? void 0 : fail({
        errMsg: err.message
      });
    }).finally(function () {
      complete === null || complete === void 0 ? void 0 : complete();
    });
  }
};
/**
 * 获取设备电量。
 */


var getBatteryInfo = (0, _mpromisify.default)(_util.limited.async('getBatteryInfo', getBatteryInfoInternal));
exports.getBatteryInfo = getBatteryInfo;