"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.vibrateShort = exports.vibrateLong = void 0;

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

var vibrateShortInternal = function vibrateShortInternal(_ref) {
  var success = _ref.success,
      fail = _ref.fail,
      complete = _ref.complete;

  if (!('vibrate' in navigator)) {
    var err = {
      errMsg: 'Your browser does not support vibrate api.'
    };
    fail === null || fail === void 0 ? void 0 : fail(err);
  } else {
    navigator.vibrate(15);
    success === null || success === void 0 ? void 0 : success();
  }

  complete === null || complete === void 0 ? void 0 : complete();
};
/**
 * 使手机发生较短时间的振动（15 ms）。
 */


var vibrateShort = (0, _mpromisify.default)(_util.limited.async('vibrateShort', vibrateShortInternal));
exports.vibrateShort = vibrateShort;

var vibrateLongInternal = function vibrateLongInternal(_ref2) {
  var success = _ref2.success,
      fail = _ref2.fail,
      complete = _ref2.complete;

  if (!('vibrate' in navigator)) {
    var err = {
      errMsg: 'Your browser does not support vibrate api.'
    };
    fail === null || fail === void 0 ? void 0 : fail(err);
  } else {
    navigator.vibrate(400);
    success === null || success === void 0 ? void 0 : success();
  }

  complete === null || complete === void 0 ? void 0 : complete();
};
/**
 * 使手机发生较长时间的振动（400 ms)。
 */


var vibrateLong = (0, _mpromisify.default)(_util.limited.async('vibrateLong', vibrateLongInternal));
exports.vibrateLong = vibrateLong;