"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTaroApp = getTaroApp;
exports.initTaroApp = initTaroApp;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _router = _interopRequireDefault(require("next/router"));

var _util = require("../_util");

function isAbsoluteUrl(url) {
  if (!url) {
    return false;
  }

  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
}

var TaroApp = /*#__PURE__*/(0, _createClass2.default)(function TaroApp(customRoutes) {
  var _this = this;

  (0, _classCallCheck2.default)(this, TaroApp);
  (0, _defineProperty2.default)(this, "pageStack", []);
  (0, _defineProperty2.default)(this, "getCurrentPages", function () {
    return _this.pageStack;
  });
  (0, _defineProperty2.default)(this, "navigateTo", function (_ref) {
    var url = _ref.url,
        success = _ref.success,
        fail = _ref.fail,
        complete = _ref.complete;

    if (!_router.default.router) {
      fail === null || fail === void 0 ? void 0 : fail();
      complete === null || complete === void 0 ? void 0 : complete();
      return;
    } // Safari 14 and below throw an error when the base parameter is undefined
    // https://bugs.webkit.org/show_bug.cgi?id=216841


    var base = isAbsoluteUrl(url) ? undefined : location.origin;
    var urlObj = base ? new URL(url, base) : new URL(url);
    var target = url;

    if (!isAbsoluteUrl(url)) {
      var customRoute = _this.customRoutes[urlObj.pathname];

      if (customRoute) {
        urlObj.pathname = customRoute;
      }

      target = urlObj.pathname + urlObj.search + urlObj.hash;
    }

    _router.default.router.push(target).then(function () {
      var page = {
        route: urlObj.pathname
      };

      _this.pageStack.push(page);

      success === null || success === void 0 ? void 0 : success();
    }).catch(fail).finally(complete);
  });
  (0, _defineProperty2.default)(this, "navigateBack", function (_ref2) {
    var success = _ref2.success,
        fail = _ref2.fail,
        complete = _ref2.complete;

    if (!_router.default.router) {
      fail === null || fail === void 0 ? void 0 : fail();
      complete === null || complete === void 0 ? void 0 : complete();
      return;
    } // Next.js internal router apis aren't support to go back twice or many times.
    // https://github.com/vercel/next.js/discussions/18333


    _router.default.router.back();

    _this.pageStack.pop();

    success === null || success === void 0 ? void 0 : success();
    complete === null || complete === void 0 ? void 0 : complete();
  });
  (0, _defineProperty2.default)(this, "redirectTo", function (_ref3) {
    var url = _ref3.url,
        complete = _ref3.complete,
        fail = _ref3.fail,
        success = _ref3.success;

    if (!_router.default.router) {
      fail === null || fail === void 0 ? void 0 : fail();
      complete === null || complete === void 0 ? void 0 : complete();
      return;
    }

    var base = isAbsoluteUrl(url) ? undefined : location.origin;
    var urlObj = base ? new URL(url, base) : new URL(url);
    var customRoute = _this.customRoutes[urlObj.pathname];

    if (customRoute) {
      urlObj.pathname = customRoute;
    }

    _router.default.router.push(urlObj.toString()).then(function () {
      var page = {
        route: urlObj.pathname
      };

      _this.pageStack.pop();

      _this.pageStack.push(page);

      success === null || success === void 0 ? void 0 : success();
    }).catch(fail).finally(complete);
  });
  (0, _defineProperty2.default)(this, "reLaunch", function (_ref4) {
    var url = _ref4.url,
        complete = _ref4.complete,
        fail = _ref4.fail,
        success = _ref4.success;

    if (!_router.default.router) {
      fail === null || fail === void 0 ? void 0 : fail();
      complete === null || complete === void 0 ? void 0 : complete();
      return;
    }

    var base = isAbsoluteUrl(url) ? undefined : location.origin;
    var urlObj = base ? new URL(url, base) : new URL(url);
    var customRoute = _this.customRoutes[urlObj.pathname];

    if (customRoute) {
      urlObj.pathname = customRoute;
    }

    _router.default.router.push(urlObj.toString()).then(function () {
      var page = {
        route: urlObj.pathname
      };
      _this.pageStack = [page];
      success === null || success === void 0 ? void 0 : success();
    }).catch(fail).finally(complete);
  });
  this.customRoutes = customRoutes;

  if (typeof window === 'undefined') {
    return;
  }

  var _page = {
    route: location.pathname
  };
  this.pageStack.push(_page);
  this.getCurrentPages = _util.limited.never('getCurrentPages', this.getCurrentPages);
  this.navigateTo = _util.limited.async('navigateTo', this.navigateTo);
  this.navigateBack = _util.limited.async('navigateBack', this.navigateBack);
  this.redirectTo = _util.limited.async('redirectTo', this.redirectTo);
  this.reLaunch = _util.limited.async('reLaunch', this.reLaunch);
});
var taroAppInstance;

function initTaroApp(customRoutes) {
  taroAppInstance = new TaroApp(customRoutes);
}

function getTaroApp() {
  return taroAppInstance;
}