"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _excluded = ["Page", "pageConfig"];
var forwardRefType;

function isForwardRefTypeComponent(component) {
  if (!forwardRefType) {
    forwardRefType = /*#__PURE__*/(0, _react.forwardRef)(function () {
      return null;
    }).$$typeof;
  }

  return component.$$typeof === forwardRefType;
}

function isClassComponent(component) {
  return typeof component === 'function' && (component.prototype instanceof _react.Component || component.prototype instanceof _react.PureComponent);
}
/**
 * 微信小程序全局 Window 配置和页面配置的公共项目
 */


var TaroPage = function TaroPage(_ref) {
  var Page = _ref.Page,
      pageConfig = _ref.pageConfig,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var ref = (0, _react.useRef)(null); // 页面配置

  (0, _react.useEffect)(function () {
    if (!pageConfig) {
      return;
    }

    var documentElement = document.documentElement;
    var backgroundColor = pageConfig.backgroundColor;
    var originBackgroundColor;

    if (backgroundColor) {
      originBackgroundColor = getComputedStyle(documentElement).backgroundColor;
      documentElement.style.backgroundColor = backgroundColor;
    }

    return function () {
      if (backgroundColor) {
        documentElement.style.backgroundColor = originBackgroundColor;
      }
    };
  }, []); // 事件订阅

  (0, _react.useEffect)(function () {
    if (!ref.current) {
      return;
    }

    var pageInstance = ref.current;

    function handleScroll() {
      var scrollingElement = document.scrollingElement || document.documentElement;
      var scrollTop = scrollingElement.scrollTop;

      if (typeof pageInstance.onPageScroll === 'function') {
        pageInstance.onPageScroll({
          scrollTop: scrollTop
        });
      }

      if (typeof pageInstance.onReachBottom === 'function') {
        var scrollHeight = Math.max(document.documentElement.scrollHeight, document.body.scrollHeight);
        var clientHeight = window.innerHeight || Math.min(document.documentElement.clientHeight, document.body.clientHeight);

        if (scrollTop >= scrollHeight - clientHeight - 60) {
          pageInstance.onReachBottom();
        }
      }
    }

    function handleResize() {
      pageInstance.onResize();
    }

    function handleVisibilityChanged() {
      if (document.visibilityState === 'visible' && typeof pageInstance.componentDidShow === 'function') {
        pageInstance.componentDidShow();
      } else if (document.visibilityState !== 'visible' && typeof pageInstance.componentDidHide === 'function') {
        pageInstance.componentDidHide();
      }
    }

    if (typeof pageInstance.onPageScroll !== 'function' || typeof pageInstance.onReachBottom !== 'function') {
      document.addEventListener('scroll', handleScroll);
    }

    if (typeof pageInstance.onResize !== 'function') {
      document.addEventListener('resize', handleResize);
    }

    if (typeof pageInstance.componentDidShow === 'function') {
      pageInstance.componentDidShow();
    }

    if (typeof pageInstance.componentDidShow === 'function' || typeof pageInstance.componentDidHide === 'function') {
      document.addEventListener('visibilitychange', handleVisibilityChanged);
    }

    return function () {
      document.removeEventListener('scroll', handleScroll);
      document.removeEventListener('resize', handleResize);
      document.removeEventListener('visibilitychange', handleVisibilityChanged);
    };
  }, []);
  var hasRef = isForwardRefTypeComponent(Page) || isClassComponent(Page);
  return /*#__PURE__*/(0, _react.createElement)(Page, (0, _objectSpread2.default)({
    ref: hasRef ? ref : undefined
  }, rest));
};

var _default = TaroPage;
exports.default = _default;