"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNetworkType = getNetworkType;
exports.onNetworkStatusChange = onNetworkStatusChange;
Object.defineProperty(exports, "request", {
  enumerable: true,
  get: function get() {
    return _request.default;
  }
});

var _request = _interopRequireDefault(require("./request"));

(function (_onNetworkStatusChange) {})(onNetworkStatusChange || (exports.onNetworkStatusChange = onNetworkStatusChange = {}));

function onNetworkStatusChange(callback) {
  function handleNetworkChanged() {
    getNetworkType({
      success: function success(_ref) {
        var networkType = _ref.networkType;
        callback({
          isConnected: networkType !== 'none',
          networkType: networkType
        });
      }
    });
  }

  var connection = navigator.connection;

  if (connection) {
    connection.addEventListener('change', handleNetworkChanged);
  } else {
    window.addEventListener('offline', handleNetworkChanged);
    window.addEventListener('online', handleNetworkChanged);
  }
}

(function (_getNetworkType) {})(getNetworkType || (exports.getNetworkType = getNetworkType = {}));

function getNetworkType(_ref2) {
  var success = _ref2.success,
      complete = _ref2.complete;
  var connection = navigator.connection;
  var networkType = 'unknown';

  if (connection) {
    networkType = connection.type;

    if (!['none', 'wifi'].includes(networkType)) {
      networkType = 'unknown';
    }
  } else if (navigator.onLine === false) {
    networkType = 'none';
  }

  success({
    networkType: networkType
  });
  complete === null || complete === void 0 ? void 0 : complete();
}