"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.openCard = exports.openBluetoothAdapter = exports.onWifiConnected = exports.onSocketOpen = exports.onSocketMessage = exports.onNetworkStatusChange = exports.onMemoryWarning = exports.onHCEMessage = exports.onGetWifiList = exports.onCompassChange = exports.onBluetoothDeviceFound = exports.onBluetoothAdapterStateChange = exports.onBeaconUpdate = exports.onBeaconServiceChange = exports.onBLEConnectionStateChange = exports.onBLECharacteristicValueChange = exports.onAccelerometerChange = exports.notifyBLECharacteristicValueChange = exports.navigateToMiniProgram = exports.navigateTo = exports.navigateBackMiniProgram = exports.navigateBack = exports.makePhoneCall = exports.login = exports.loadFontFace = exports.hideToast = exports.hideTabBarRedDot = exports.hideTabBar = exports.hideShareMenu = exports.hideLoading = exports.getWifiList = exports.getWeRunData = exports.getUserInfo = exports.getSystemInfoSync = exports.getSystemInfo = exports.getStorageInfoSync = exports.getStorageInfo = exports.getStorage = exports.getShareInfo = exports.getSetting = exports.getScreenBrightness = exports.getSavedFileList = exports.getSavedFileInfo = exports.getNetworkType = exports.getLocation = exports.getImageInfo = exports.getHCEState = exports.getFileInfo = exports.getExtConfigSync = exports.getExtConfig = exports.getConnectedWifi = exports.getConnectedBluetoothDevices = exports.getClipboardData = exports.getBluetoothDevices = exports.getBluetoothAdapterState = exports.getBeacons = exports.getBatteryInfoSync = exports.getBatteryInfo = exports.getBackgroundAudioPlayerState = exports.getBLEDeviceServices = exports.getBLEDeviceCharacteristics = exports.getAvailableAudioSources = exports.downloadFile = exports.createBLEConnection = exports.createAnimation = exports.connectWifi = exports.connectSocket = exports.closeSocket = exports.closeBluetoothAdapter = exports.closeBLEConnection = exports.clearStorage = exports.chooseVideo = exports.chooseLocation = exports.chooseInvoiceTitle = exports.chooseImage = exports.chooseAddress = exports.checkSession = exports.checkIsSupportSoterAuthentication = exports.checkIsSoterEnrolledInDevice = exports.canvasToTempFilePath = exports.canvasPutImageData = exports.canvasGetImageData = exports.authorize = exports.addPhoneContact = exports.addCard = exports.Worker = exports.VideoContext = exports.UpdateManager = exports.SocketTask = exports.SelectorQuery = exports.RecorderManager = exports.MapContext = exports.LivePusherContext = exports.LivePlayerContext = exports.InnerAudioContext = exports.CanvasContext = exports.CameraContext = exports.BackgroundAudioManager = exports.AudioContext = exports.Animation = void 0;
exports.writeBLECharacteristicValue = exports.vibrateShort = exports.vibrateLong = exports.uploadFile = exports.updateShareMenu = exports.switchTab = exports.stopWifi = exports.stopHCE = exports.stopCompass = exports.stopBluetoothDevicesDiscovery = exports.stopBeaconDiscovery = exports.stopAccelerometer = exports.startWifi = exports.startSoterAuthentication = exports.startRecord = exports.startPullDownRefresh = exports.startHCE = exports.startCompass = exports.startBluetoothDevicesDiscovery = exports.startBeaconDiscovery = exports.startAccelerometer = exports.showToast = exports.showTabBarRedDot = exports.showTabBar = exports.showShareMenu = exports.showModal = exports.showLoading = exports.showActionSheet = exports.setWifiList = exports.setTopBarText = exports.setTabBarStyle = exports.setTabBarItem = exports.setTabBarBadge = exports.setStorage = exports.setScreenBrightness = exports.setNavigationBarTitle = exports.setNavigationBarColor = exports.setKeepScreenOn = exports.setEnableDebug = exports.setClipboardData = exports.setBackgroundTextStyle = exports.setBackgroundColor = exports.sendSocketMessage = exports.sendHCEMessage = exports.seekBackgroundAudio = exports.scanCode = exports.saveVideoToPhotosAlbum = exports.saveImageToPhotosAlbum = exports.saveFile = exports.requestPayment = exports.request = exports.removeTabBarBadge = exports.removeStorage = exports.removeSavedFile = exports.redirectTo = exports.readBLECharacteristicValue = exports.reLaunch = exports.previewImage = exports.playVoice = exports.playBackgroundAudio = exports.pageScrollTo = exports.openSetting = exports.openLocation = exports.openDocument = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var request;
/**
 * 发起网络请求。**使用前请先阅读[说明](https://smartapp.baidu.com/docs/develop/api/net/)**。
 *
 * **返回值：**
 *
 *
 * 返回一个 `requestTask` 对象，通过 `requestTask`，可中断请求任务。
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: content-export type 默认为 'application/json';
 * 2.  `bug`: 开发者工具 `0.10.102800` 版本，`header` 的 `content-export type` 设置异常；
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.request({
 *       url: 'test.php', //仅为示例，并非真实的接口地址
 *       data: {
 *          x: '' ,
 *          y: ''
 *       },
 *       header: {
 *           'content-export type': 'application/json' // 默认值
 *       },
 *       success: function(res) {
 *         console.log(res.data)
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const requestTask = swan.request({
 *       url: 'test.php', //仅为示例，并非真实的接口地址
 *       data: {
 *          x: '' ,
 *          y: ''
 *       },
 *       header: {
 *           'content-export type': 'application/json'
 *       },
 *       success: function(res) {
 *         console.log(res.data)
 *       }
 *     })
 *
 *     requestTask.abort() // 取消请求任务
 *     ```
 * 
 */

exports.request = request;

(function (_request) {})(request || (exports.request = request = {}));

var uploadFile;
/**
 * 将本地资源上传到开发者服务器，客户端发起一个 HTTPS POST 请求，其中 `content-export type` 为 `multipart/form-data` 。
 *
 * 如页面通过 [swan.chooseImage](https://smartapp.baidu.com/docs/develop/api/media/#chooseImage) 等接口获取到一个本地资源的临时文件路径后，可通过此接口将本地资源上传到指定服务器。
 *
 * **返回值：**
 *
 *
 * 返回一个 `uploadTask` 对象，通过 `uploadTask`，可监听上传进度变化事件，以及取消上传任务。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseImage({
 *       success: function(res) {
 *         var tempFilePaths = res.tempFilePaths
 *         swan.uploadFile({
 *           url: 'https://smartprogram.baidu.com/xxx', // 开发者服务器 url
 *           filePath: tempFilePaths[0],
 *           name: 'file',
 *           formData:{
 *             'user': 'test'
 *           },
 *           success: function(res){
 *             var data = res.data
 *             //do something
 *           }
 *         })
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const uploadTask = swan.uploadFile({
 *         url: 'https://smartprogram.baidu.com/xxx', // 开发者服务器 url
 *         filePath: tempFilePaths[0],
 *         name: 'file',
 *         formData:{
 *             'user': 'test'
 *         },
 *         success: function(res){
 *             var data = res.data
 *             //do something
 *         }
 *     })
 *
 *     uploadTask.onProgressUpdate((res) => {
 *         console.log('上传进度', res.progress)
 *         console.log('已经上传的数据长度', res.totalBytesSent)
 *         console.log('预期需要上传的数据总长度', res.totalBytesExpectedToSend)
 *     })
 *
 *     uploadTask.abort() // 取消上传任务
 *     ```
 * 
 */

exports.uploadFile = uploadFile;

(function (_uploadFile) {})(uploadFile || (exports.uploadFile = uploadFile = {}));

var downloadFile;
/**
 * 下载文件资源到本地，客户端直接发起一个 HTTP GET 请求，返回文件的本地临时路径。
 *
 * **返回值：**
 *
 *
 * 返回一个 `downloadTask` 对象，通过 `downloadTask`，可监听下载进度变化事件，以及取消下载任务。
 *
 * **Tips：**
 *
 * 1. 文件的临时路径，在智能小程序本次启动期间可以正常使用，如需持久保存，需再主动调用 swan.saveFile，才能在智能小程序下次启动时访问得到。
 * 2. 请在 header 中指定合理的 Content-Type 字段，以保证客户端正确处理文件类型  
 * 3. uploadFile 上传文件大小限制为 25M。       
 * 
 * **示例代码：**
 *
 *     ```javascript
 *     swan.downloadFile({
 *       url: 'https://smartprogram.baidu.com/xxx', //仅为示例，并非真实的资源
 *       success: function(res) {
 *         // 只要服务器有响应数据，就会把响应内容写入文件并进入 success 回调，业务需要自行判断是否下载到了想要的内容
 *         if (res.statusCode === 200) {
 *             swan.playVoice({
 *               filePath: res.tempFilePath
 *             })
 *         }
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const downloadTask = swan.downloadFile({
 *         url: 'https://smartprogram.baidu.com/xxx', //仅为示例，并非真实的资源
 *         success: function(res) {
 *             swan.playVoice({
 *                 filePath: res.tempFilePath
 *             })
 *         }
 *     })
 *
 *     downloadTask.onProgressUpdate((res) => {
 *         console.log('下载进度', res.progress)
 *         console.log('已经下载的数据长度', res.totalBytesWritten)
 *         console.log('预期需要下载的数据总长度', res.totalBytesExpectedToWrite)
 *     })
 *
 *     downloadTask.abort() // 取消下载任务
 *     ```
 * 
 */

exports.downloadFile = downloadFile;

(function (_downloadFile) {})(downloadFile || (exports.downloadFile = downloadFile = {}));

var connectSocket;
/**
 * 创建一个 [WebSocket](https://developer.mozilla.org/zh-CN/docs/Web/API/WebSocket) 连接。
 *
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'wss://example.baidu.com',
 *       data:{
 *         x: '',
 *         y: ''
 *       },
 *       header:{ 
 *         'content-export type': 'application/json'
 *       },
 *       protocols: ['protocol1'],
 *       method:"GET"
 *     })
 *     ```
 * 
 */

exports.connectSocket = connectSocket;

(function (_connectSocket) {})(connectSocket || (exports.connectSocket = connectSocket = {}));

var onSocketOpen;
/**
 * 监听WebSocket连接打开事件。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *     swan.onSocketOpen(function(res) {
 *       console.log('WebSocket连接已打开！')
 *     })
 *     ```
 * 
 */

exports.onSocketOpen = onSocketOpen;

(function (_onSocketOpen) {})(onSocketOpen || (exports.onSocketOpen = onSocketOpen = {}));

var sendSocketMessage;
/**
 * 通过 WebSocket 连接发送数据，需要先 [swan.connectSocket](https://smartapp.baidu.com/docs/develop/api/net/#connectSocket)，并在 [swan.onSocketOpen](https://smartapp.baidu.com/docs/develop/api/net/#onSocketOpen) 回调之后才能发送。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     var socketOpen = false
 *     var socketMsgQueue = []
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *
 *     swan.onSocketOpen(function(res) {
 *       socketOpen = true
 *       for (var i = 0; i < socketMsgQueue.length; i++){
 *          sendSocketMessage(socketMsgQueue[i])
 *       }
 *       socketMsgQueue = []
 *     })
 *
 *     export function sendSocketMessage(msg) {
 *       if (socketOpen) {
 *         swan.sendSocketMessage({
 *           data:msg
 *         })
 *       } else {
 *          socketMsgQueue.push(msg)
 *       }
 *     }
 *     ```
 * 
 */

exports.sendSocketMessage = sendSocketMessage;

(function (_sendSocketMessage) {})(sendSocketMessage || (exports.sendSocketMessage = sendSocketMessage = {}));

var onSocketMessage;
/**
 * 监听WebSocket接受到服务器的消息事件。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectSocket({
 *       url: 'test.php'
 *     })
 *
 *     swan.onSocketMessage(function(res) {
 *       console.log('收到服务器内容：' + res.data)
 *     })
 *     ```
 * 
 */

exports.onSocketMessage = onSocketMessage;

(function (_onSocketMessage) {})(onSocketMessage || (exports.onSocketMessage = onSocketMessage = {}));

var closeSocket;
/**
 * 关闭 WebSocket 连接。
 * 
 */

exports.closeSocket = closeSocket;

(function (_closeSocket) {})(closeSocket || (exports.closeSocket = closeSocket = {}));

(function (_SocketTask) {
  var send;

  (function (_send) {})(send || (send = _SocketTask.send || (_SocketTask.send = {})));

  var close;

  (function (_close) {})(close || (close = _SocketTask.close || (_SocketTask.close = {})));

  var onOpen;

  (function (_onOpen) {})(onOpen || (onOpen = _SocketTask.onOpen || (_SocketTask.onOpen = {})));

  var onError;

  (function (_onError) {})(onError || (onError = _SocketTask.onError || (_SocketTask.onError = {})));

  var onMessage;

  (function (_onMessage) {})(onMessage || (onMessage = _SocketTask.onMessage || (_SocketTask.onMessage = {})));
})(SocketTask || (exports.SocketTask = SocketTask = {}));
/**
 *
 * WebSocket 任务，可通过 swan.connectSocket()接口创建返回。
 */


var SocketTask = /*#__PURE__*/(0, _createClass2.default)(function SocketTask() {
  (0, _classCallCheck2.default)(this, SocketTask);
});
exports.SocketTask = SocketTask;
var chooseImage;
/**
 * 从本地相册选择图片或使用相机拍照。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseImage({
 *       count: 1, // 默认9
 *       sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
 *       sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
 *       success: export function (res) {
 *         // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
 *         var tempFilePaths = res.tempFilePaths
 *       }
 *     })
 *     ```
 */

exports.chooseImage = chooseImage;

(function (_chooseImage) {})(chooseImage || (exports.chooseImage = chooseImage = {}));

var previewImage;
/**
 * 预览图片。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.previewImage({
 *       current: '', // 当前显示图片的http链接
 *       urls: [] // 需要预览的图片http链接列表
 *     })
 *     ```
 * 
 */

exports.previewImage = previewImage;

(function (_previewImage) {})(previewImage || (exports.previewImage = previewImage = {}));

var getImageInfo;
/**
 * 获取图片信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getImageInfo({
 *       src: 'images/a.jpg',
 *       success: export function (res) {
 *         console.log(res.width)
 *         console.log(res.height)
 *       }
 *     })
 *
 *     swan.chooseImage({
 *       success: export function (res) {
 *         swan.getImageInfo({
 *           src: res.tempFilePaths[0],
 *           success: export function (res) {
 *             console.log(res.width)
 *             console.log(res.height)
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.getImageInfo = getImageInfo;

(function (_getImageInfo) {})(getImageInfo || (exports.getImageInfo = getImageInfo = {}));

var saveImageToPhotosAlbum;
/**
 * 保存图片到系统相册。需要用户授权scope.writePhotosAlbum
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.saveImageToPhotosAlbum({
 *         success(res) {
 *         }
 *     })
 *     ```
 */

exports.saveImageToPhotosAlbum = saveImageToPhotosAlbum;

(function (_saveImageToPhotosAlbum) {})(saveImageToPhotosAlbum || (exports.saveImageToPhotosAlbum = saveImageToPhotosAlbum = {}));

var startRecord;
/**
 * **注意：1.6.0 版本开始，本接口不再维护。建议使用能力更强的swan.getRecorderManager接口**
 *
 * 开始录音。当主动调用`swan.stopRecord`，或者录音超过1分钟时自动结束录音，返回录音文件的临时文件路径。当用户离开小程序时，此接口无法调用。
 *
 * 需要用户授权scope.record
 * 
 */

exports.startRecord = startRecord;

(function (_startRecord) {})(startRecord || (exports.startRecord = startRecord = {}));

(function (_RecorderManager) {
  var start;

  (function (_start) {})(start || (start = _RecorderManager.start || (_RecorderManager.start = {})));

  var onStop;

  (function (_onStop) {})(onStop || (onStop = _RecorderManager.onStop || (_RecorderManager.onStop = {})));

  var onFrameRecorded;

  (function (_onFrameRecorded) {})(onFrameRecorded || (onFrameRecorded = _RecorderManager.onFrameRecorded || (_RecorderManager.onFrameRecorded = {})));

  var onError;

  (function (_onError3) {})(onError || (onError = _RecorderManager.onError || (_RecorderManager.onError = {})));
})(RecorderManager || (exports.RecorderManager = RecorderManager = {}));

var RecorderManager = /*#__PURE__*/(0, _createClass2.default)(function RecorderManager() {
  (0, _classCallCheck2.default)(this, RecorderManager);
});
exports.RecorderManager = RecorderManager;
var playVoice;
/**
 * **注意：1.6.0 版本开始，本接口不再维护。建议使用能力更强的 [swan.createInnerAudioContext]接口**
 *
 * 开始播放语音，同时只允许一个语音文件正在播放，如果前一个语音文件还没播放完，将中断前一个语音播放。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startRecord({
 *       success: function(res) {
 *         var tempFilePath = res.tempFilePath
 *         swan.playVoice({
 *           filePath: tempFilePath,
 *           complete: function(){
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.playVoice = playVoice;

(function (_playVoice) {})(playVoice || (exports.playVoice = playVoice = {}));

var getBackgroundAudioPlayerState;
/**
 * **注意：1.2.0 版本开始，本接口不再维护。建议使用能力更强的 swan.getBackgroundAudioManager接口**
 *
 * 获取后台音乐播放状态。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBackgroundAudioPlayerState({
 *         success: function(res) {
 *             var status = res.status
 *             var dataUrl = res.dataUrl
 *             var currentPosition = res.currentPosition
 *             var duration = res.duration
 *             var downloadPercent = res.downloadPercent
 *         }
 *     })
 *     ```
 * 
 */

exports.getBackgroundAudioPlayerState = getBackgroundAudioPlayerState;

(function (_getBackgroundAudioPlayerState) {})(getBackgroundAudioPlayerState || (exports.getBackgroundAudioPlayerState = getBackgroundAudioPlayerState = {}));

var playBackgroundAudio;
/**
 * 使用后台播放器播放音乐，对于客户端来说，只能同时有一个后台音乐在播放。当用户离开小程序后，音乐将暂停播放；当用户点击“显示在聊天顶部”时，音乐不会暂停播放；当用户在其他小程序占用了音乐播放器，原有小程序内的音乐将停止播放。
 *
 * **OBJECT参数说明：**
 *
 *     ```javascript
 *     swan.playBackgroundAudio({
 *         dataUrl: '',
 *         title: '',
 *         coverImgUrl: ''
 *     })
 *     ```
 * 
 */

exports.playBackgroundAudio = playBackgroundAudio;

(function (_playBackgroundAudio) {})(playBackgroundAudio || (exports.playBackgroundAudio = playBackgroundAudio = {}));

var seekBackgroundAudio;
/**
 * 控制音乐播放进度。
 *
 * **OBJECT参数说明：**
 *
 *     ```javascript
 *     swan.seekBackgroundAudio({
 *         position: 30
 *     })
 *     ```
 */

exports.seekBackgroundAudio = seekBackgroundAudio;

(function (_seekBackgroundAudio) {})(seekBackgroundAudio || (exports.seekBackgroundAudio = seekBackgroundAudio = {}));

var BackgroundAudioManager = /*#__PURE__*/(0, _createClass2.default)(function BackgroundAudioManager() {
  (0, _classCallCheck2.default)(this, BackgroundAudioManager);
});
/**
 * **注意：1.6.0 版本开始，本接口不再维护。建议使用能力更强的 [swan.createInnerAudioContext]() 接口**
 *
 * 创建并返回 audio 上下文 `audioContext` 对象。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<audio/>` 组件
 *
 * **audioContext：**
 *
 * `audioContext` 通过 audioId 跟一个 `<audio/>` 组件绑定，通过它可以操作对应的 `<audio/>` 组件。
 *
 * **示例代码：**
 *
 *     ```html
 *     <!-- audio.swan -->
 *     <audio  src="{{src}}" id="myAudio" ></audio>
 *
 *     <button export type="primary" bindtap="audioPlay">播放</button>
 *     <button export type="primary" bindtap="audioPause">暂停</button>
 *     <button export type="primary" bindtap="audio14">设置当前播放时间为14秒</button>
 *     <button export type="primary" bindtap="audioStart">回到开头</button>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // audio.js
 *     Page({
 *       onReady: export function (e) {
 *         // 使用 swan.createAudioContext 获取 audio 上下文 context
 *         this.audioCtx = swan.createAudioContext('myAudio')
 *         this.audioCtx.setSrc('http://ws.stream.qqmusic.qq.com/M500001VfvsJ21xFqb.mp3?guid=ffffffff82def4af4b12b3cd9337d5e7&uin=346897220&vkey=6292F51E1E384E06DCBDC9AB7C49FD713D632D313AC4858BACB8DDD29067D3C601481D36E62053BF8DFEAF74C0A5CCFADD6471160CAF3E6A&fromtag=46')
 *         this.audioCtx.play()
 *       },
 *       data: {
 *         src: ''
 *       },
 *       audioPlay: export function () {
 *         this.audioCtx.play()
 *       },
 *       audioPause: export function () {
 *         this.audioCtx.pause()
 *       },
 *       audio14: export function () {
 *         this.audioCtx.seek(14)
 *       },
 *       audioStart: export function () {
 *         this.audioCtx.seek(0)
 *       }
 *     })
 *     ```
 * 
 */

exports.BackgroundAudioManager = BackgroundAudioManager;
var AudioContext = /*#__PURE__*/(0, _createClass2.default)(function AudioContext() {
  (0, _classCallCheck2.default)(this, AudioContext);
});
/**
 * 
 *
 * 创建并返回内部 audio 上下文 `innerAudioContext` 对象。_本接口是 `swan.createAudioContext` 升级版。_
 *
 * **errCode 说明：**
 *
 *   errCode   |  说明   
 * ------------|---------
 *   10001     | 系统错误
 *   10002     | 网络错误
 *   10003     | 文件错误
 *   10004     | 格式错误
 *   -1        | 未知错误
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const innerAudioContext = swan.createInnerAudioContext()
 *     innerAudioContext.autoplay = true
 *     innerAudioContext.src = 'http://ws.stream.qqmusic.qq.com/M500001VfvsJ21xFqb.mp3?guid=ffffffff82def4af4b12b3cd9337d5e7&uin=346897220&vkey=6292F51E1E384E061FF02C31F716658E5C81F5594D561F2E88B854E81CAAB7806D5E4F103E55D33C16F3FAC506D1AB172DE8600B37E43FAD&fromtag=46'
 *     innerAudioContext.onPlay(() => {
 *         console.log('开始播放')
 *     })
 *     innerAudioContext.onError((res) => {
 *         console.log(res.errMsg)
 *         console.log(res.errCode)
 *     })
 *     ```
 * 
 */

exports.AudioContext = AudioContext;
var InnerAudioContext = /*#__PURE__*/(0, _createClass2.default)(function InnerAudioContext() {
  (0, _classCallCheck2.default)(this, InnerAudioContext);
});
exports.InnerAudioContext = InnerAudioContext;
var getAvailableAudioSources;
/**
 * 
 *
 * **audioSource 有效值：：**
 *
 *   值           |  说明                              |  支持平台               
 * ---------------|------------------------------------|-------------------------
 *   auto         |自动设置，默认使用手机麦克风，插上耳麦后自动切换使用耳机麦克风|  iOS/Android/devtools   
 *   buildInMic   |  手机麦克风                        |  iOS                    
 *   headsetMic   |  耳机麦克风                        |  iOS                    
 *   mic          |麦克风（没插耳麦时是手机麦克风，插耳麦时是耳机麦克风|  Android                
 *   camcorder    |  摄像头的麦克风                    |  Android                
 * 
 */

exports.getAvailableAudioSources = getAvailableAudioSources;

(function (_getAvailableAudioSources) {})(getAvailableAudioSources || (exports.getAvailableAudioSources = getAvailableAudioSources = {}));

var chooseVideo;
/**
 * 拍摄视频或从手机相册中选视频，返回视频的临时文件路径。
 *
 * **示例代码：**
 *
 *     ```html
 *     <view class="container">
 *         <video src="{{src}}"></video>
 *         <button bindtap="bindButtonTap">获取视频</button>
 *     </view>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     Page({
 *         bindButtonTap: function() {
 *             var that = this
 *             swan.chooseVideo({
 *                 sourceType: ['album','camera'],
 *                 maxDuration: 60,
 *           camera: 'back',
 *                 success: function(res) {
 *                     that.setData({
 *                         src: res.tempFilePath
 *                     })
 *                 }
 *             })
 *         }
 *     })
 *     ```
 * 
 */

exports.chooseVideo = chooseVideo;

(function (_chooseVideo) {})(chooseVideo || (exports.chooseVideo = chooseVideo = {}));

var saveVideoToPhotosAlbum;
/**
 * 
 *
 * 保存视频到系统相册。需要用户授权 scope.writePhotosAlbum
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: camera 参数在部分 Android 手机下由于系统 ROM 不支持无法生效
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.saveVideoToPhotosAlbum({
 *       filePath: 'swanfile://xxx'
 *       success(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.saveVideoToPhotosAlbum = saveVideoToPhotosAlbum;

(function (_saveVideoToPhotosAlbum) {})(saveVideoToPhotosAlbum || (exports.saveVideoToPhotosAlbum = saveVideoToPhotosAlbum = {}));

var VideoContext = /*#__PURE__*/(0, _createClass2.default)(function VideoContext() {
  (0, _classCallCheck2.default)(this, VideoContext);
});
/**
 * 
 *
 * 创建并返回 camera 上下文 `cameraContext` 对象，`cameraContext` 与页面的 `camera` 组件绑定，一个页面只能有一个camera，通过它可以操作对应的 `<camera/>` 组件。 在自定义组件下，第一个参数传入组件实例this，以操作组件内 `<camera/>` 组件
 *
 * **示例代码：**
 *
 * 在开发者工具中预览效果
 * 
 */

exports.VideoContext = VideoContext;

(function (_CameraContext) {
  var takePhoto;

  (function (_takePhoto) {})(takePhoto || (takePhoto = _CameraContext.takePhoto || (_CameraContext.takePhoto = {})));

  var startRecord;

  (function (_startRecord2) {})(startRecord || (startRecord = _CameraContext.startRecord || (_CameraContext.startRecord = {})));

  var stopRecord;

  (function (_stopRecord) {})(stopRecord || (stopRecord = _CameraContext.stopRecord || (_CameraContext.stopRecord = {})));
})(CameraContext || (exports.CameraContext = CameraContext = {}));

var CameraContext = /*#__PURE__*/(0, _createClass2.default)(function CameraContext() {
  (0, _classCallCheck2.default)(this, CameraContext);
});
/**
 * 
 *
 * 操作对应的 `<live-player/>` 组件。 创建并返回 `live-player` 上下文 `LivePlayerContext` 对象。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<live-player/>` 组件
 *
 * **示例代码：**
 *
 * 在开发者工具中预览效果
 * 
 */

exports.CameraContext = CameraContext;

(function (_LivePlayerContext) {
  var play;

  (function (_play) {})(play || (play = _LivePlayerContext.play || (_LivePlayerContext.play = {})));

  var stop;

  (function (_stop) {})(stop || (stop = _LivePlayerContext.stop || (_LivePlayerContext.stop = {})));

  var mute;

  (function (_mute) {})(mute || (mute = _LivePlayerContext.mute || (_LivePlayerContext.mute = {})));

  var pause;

  (function (_pause) {})(pause || (pause = _LivePlayerContext.pause || (_LivePlayerContext.pause = {})));

  var resume;

  (function (_resume) {})(resume || (resume = _LivePlayerContext.resume || (_LivePlayerContext.resume = {})));

  var requestFullScreen;

  (function (_requestFullScreen) {})(requestFullScreen || (requestFullScreen = _LivePlayerContext.requestFullScreen || (_LivePlayerContext.requestFullScreen = {})));

  var exitFullScreen;

  (function (_exitFullScreen) {})(exitFullScreen || (exitFullScreen = _LivePlayerContext.exitFullScreen || (_LivePlayerContext.exitFullScreen = {})));
})(LivePlayerContext || (exports.LivePlayerContext = LivePlayerContext = {}));

var LivePlayerContext = /*#__PURE__*/(0, _createClass2.default)(function LivePlayerContext() {
  (0, _classCallCheck2.default)(this, LivePlayerContext);
});
/**
 * 
 *
 * 创建并返回 `live-pusher` 上下文 `LivePusherContext` 对象，`LivePusherContext` 与页面的 `<live-pusher />` 组件绑定，一个页面只能有一个 `live-pusher`，通过它可以操作对应的 `<live-pusher/>` 组件。 在自定义组件下，第一个参数传入组件实例this，以操作组件内 `<live-pusher/>` 组件
 *
 * **示例代码：**
 *
 * 在开发者工具中预览效果
 * 
 */

exports.LivePlayerContext = LivePlayerContext;

(function (_LivePusherContext) {
  var start;

  (function (_start3) {})(start || (start = _LivePusherContext.start || (_LivePusherContext.start = {})));

  var stop;

  (function (_stop3) {})(stop || (stop = _LivePusherContext.stop || (_LivePusherContext.stop = {})));

  var pause;

  (function (_pause3) {})(pause || (pause = _LivePusherContext.pause || (_LivePusherContext.pause = {})));

  var resume;

  (function (_resume3) {})(resume || (resume = _LivePusherContext.resume || (_LivePusherContext.resume = {})));

  var switchCamera;

  (function (_switchCamera) {})(switchCamera || (switchCamera = _LivePusherContext.switchCamera || (_LivePusherContext.switchCamera = {})));

  var snapshot;

  (function (_snapshot) {})(snapshot || (snapshot = _LivePusherContext.snapshot || (_LivePusherContext.snapshot = {})));

  var toggleTorch;

  (function (_toggleTorch) {})(toggleTorch || (toggleTorch = _LivePusherContext.toggleTorch || (_LivePusherContext.toggleTorch = {})));
})(LivePusherContext || (exports.LivePusherContext = LivePusherContext = {}));

var LivePusherContext = /*#__PURE__*/(0, _createClass2.default)(function LivePusherContext() {
  (0, _classCallCheck2.default)(this, LivePusherContext);
});
exports.LivePusherContext = LivePusherContext;
var loadFontFace;
/**
 * 
 *
 * 动态加载网络字体
 *
 * **Tip：**
 *
 * 1.  引入的外部字体资源，建议格式为TTF和WOFF，WOFF2在低版本的IOS上会不兼容。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.loadFontFace({
 *       family: 'Bitstream Vera Serif Bold',
 *       source: 'url("http://developer.mozilla.org/@api/deki/files/2934/=VeraSeBd.ttf")',
 *       success: function(res) {
 *         console.log(res.status) //  loaded
 *       },
 *       fail: function(res) {
 *         console.log(res.status) //  error
 *       },
 *       complete: function(res) {
 *         console.log(res.status);
 *       }
 *     });
 *     ```
 * 
 */

exports.loadFontFace = loadFontFace;

(function (_loadFontFace) {})(loadFontFace || (exports.loadFontFace = loadFontFace = {}));

var saveFile;
/**
 * 保存文件到本地。**注意：saveFile 会把临时文件移动，因此调用成功后传入的 tempFilePath 将不可用**
 *
 * **bug & tip：**
 *
 * 1.  `tip`: 本地文件存储的大小限制为 10M
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseImage({
 *       success: function(res) {
 *         var tempFilePaths = res.tempFilePaths
 *         swan.saveFile({
 *           tempFilePath: tempFilePaths[0],
 *           success: function(res) {
 *             var savedFilePath = res.savedFilePath
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.saveFile = saveFile;

(function (_saveFile) {})(saveFile || (exports.saveFile = saveFile = {}));

var getSavedFileList;
/**
 * 获取本地已保存的文件列表
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSavedFileList({
 *       success: function(res) {
 *         console.log(res.fileList)
 *       }
 *     })
 *     ```
 * 
 */

exports.getSavedFileList = getSavedFileList;

(function (_getSavedFileList) {})(getSavedFileList || (exports.getSavedFileList = getSavedFileList = {}));

var getSavedFileInfo;
/**
 * 获取本地文件的文件信息。此接口只能用于获取已保存到本地的文件，若需要获取临时文件信息，请使用 [swan.getFileInfo]() 接口。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSavedFileInfo({
 *       filePath: 'swanfile://somefile', //仅做示例用，非真正的文件路径
 *       success: function(res) {
 *         console.log(res.size)
 *         console.log(res.createTime)
 *       }
 *     })
 *     ```
 * 
 */

exports.getSavedFileInfo = getSavedFileInfo;

(function (_getSavedFileInfo) {})(getSavedFileInfo || (exports.getSavedFileInfo = getSavedFileInfo = {}));

var removeSavedFile;
/**
 * 删除本地存储的文件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSavedFileList({
 *       success: function(res) {
 *         if (res.fileList.length > 0){
 *           swan.removeSavedFile({
 *             filePath: res.fileList[0].filePath,
 *             complete: function(res) {
 *               console.log(res)
 *             }
 *           })
 *         }
 *       }
 *     })
 *     ```
 * 
 */

exports.removeSavedFile = removeSavedFile;

(function (_removeSavedFile) {})(removeSavedFile || (exports.removeSavedFile = removeSavedFile = {}));

var openDocument;
/**
 * 新开页面打开文档，支持格式：doc, xls, ppt, pdf, docx, xlsx, pptx
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.downloadFile({
 *       url: 'http://example.com/somefile.pdf',
 *       success: export function (res) {
 *         var filePath = res.tempFilePath
 *         swan.openDocument({
 *           filePath: filePath,
 *           success: export function (res) {
 *             console.log('打开文档成功')
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.openDocument = openDocument;

(function (_openDocument) {})(openDocument || (exports.openDocument = openDocument = {}));

var getFileInfo;
/**
 * 
 *
 * 获取文件信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getFileInfo({
 *         success(res) {
 *             console.log(res.size)
 *             console.log(res.digest)
 *         }
 *     })
 *     ```
 * 
 */

exports.getFileInfo = getFileInfo;

(function (_getFileInfo) {})(getFileInfo || (exports.getFileInfo = getFileInfo = {}));

var setStorage;
/**
 * 将数据存储在本地缓存中指定的 key 中，会覆盖掉原来该 key 对应的内容，这是一个异步接口。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setStorage({
 *       key:"key",
 *       data:"value"
 *     })
 *     ```
 * 
 */

exports.setStorage = setStorage;

(function (_setStorage) {})(setStorage || (exports.setStorage = setStorage = {}));

var getStorage;
/**
 * 从本地缓存中异步获取指定 key 对应的内容。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getStorage({
 *       key: 'key',
 *       success: function(res) {
 *           console.log(res.data)
 *       } 
 *     })
 *     ```
 * 
 */

exports.getStorage = getStorage;

(function (_getStorage) {})(getStorage || (exports.getStorage = getStorage = {}));

var getStorageInfo;
/**
 * 异步获取当前storage的相关信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getStorageInfo({
 *       success: function(res) {
 *         console.log(res.keys)
 *         console.log(res.currentSize)
 *         console.log(res.limitSize)
 *       }
 *     })
 *     ```
 * 
 */

exports.getStorageInfo = getStorageInfo;

(function (_getStorageInfo) {})(getStorageInfo || (exports.getStorageInfo = getStorageInfo = {}));

var getStorageInfoSync;
/**
 * 同步获取当前storage的相关信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *       var res = swan.getStorageInfoSync()
 *       console.log(res.keys)
 *       console.log(res.currentSize)
 *       console.log(res.limitSize)
 *     } catch (e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */

exports.getStorageInfoSync = getStorageInfoSync;

(function (_getStorageInfoSync) {})(getStorageInfoSync || (exports.getStorageInfoSync = getStorageInfoSync = {}));

var removeStorage;
/**
 * 从本地缓存中异步移除指定 key 。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.removeStorage({
 *       key: 'key',
 *       success: function(res) {
 *         console.log(res.data)
 *       } 
 *     })
 *     ```
 * 
 */

exports.removeStorage = removeStorage;

(function (_removeStorage) {})(removeStorage || (exports.removeStorage = removeStorage = {}));

var clearStorage;
/**
 * 清理本地数据缓存。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.clearStorage()
 *     ```
 * 
 */

exports.clearStorage = clearStorage;

(function (_clearStorage) {})(clearStorage || (exports.clearStorage = clearStorage = {}));

var getLocation;
/**
 * 获取当前的地理位置、速度。当用户离开小程序后，此接口无法调用；当用户点击“显示在聊天顶部”时，此接口可继续调用。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getLocation({
 *       export type: 'wgs84',
 *       success: function(res) {
 *         var latitude = res.latitude
 *         var longitude = res.longitude
 *         var speed = res.speed
 *         var accuracy = res.accuracy
 *       }
 *     })
 *     ```
 * 
 */

exports.getLocation = getLocation;

(function (_getLocation) {})(getLocation || (exports.getLocation = getLocation = {}));

var chooseLocation;
/**
 * 打开地图选择位置。
 *
 * 需要用户授权scope.userLocation
 * 
 */

exports.chooseLocation = chooseLocation;

(function (_chooseLocation) {})(chooseLocation || (exports.chooseLocation = chooseLocation = {}));

var openLocation;
/**
 * 使用内置地图查看位置。
 *
 * 需要用户授权scope.userLocation
 *
 * **Bug & Tip：**
 *
 * 1.  `bug`: `iOS` `6.3.30` export type 参数不生效，只会返回 wgs84 类型的坐标信息
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getLocation({
 *       export type: 'gcj02', //返回可以用于swan.openLocation的经纬度
 *       success: function(res) {
 *         var latitude = res.latitude
 *         var longitude = res.longitude
 *         swan.openLocation({
 *           latitude: latitude,
 *           longitude: longitude,
 *           scale: 28
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.openLocation = openLocation;

(function (_openLocation) {})(openLocation || (exports.openLocation = openLocation = {}));

(function (_MapContext) {
  var getCenterLocation;

  (function (_getCenterLocation) {})(getCenterLocation || (getCenterLocation = _MapContext.getCenterLocation || (_MapContext.getCenterLocation = {})));

  var translateMarker;

  (function (_translateMarker) {})(translateMarker || (translateMarker = _MapContext.translateMarker || (_MapContext.translateMarker = {})));

  var includePoints;

  (function (_includePoints) {})(includePoints || (includePoints = _MapContext.includePoints || (_MapContext.includePoints = {})));

  var getRegion;

  (function (_getRegion) {})(getRegion || (getRegion = _MapContext.getRegion || (_MapContext.getRegion = {})));

  var getScale;

  (function (_getScale) {})(getScale || (getScale = _MapContext.getScale || (_MapContext.getScale = {})));
})(MapContext || (exports.MapContext = MapContext = {}));

var MapContext = /*#__PURE__*/(0, _createClass2.default)(function MapContext() {
  (0, _classCallCheck2.default)(this, MapContext);
});
exports.MapContext = MapContext;
var getSystemInfo;
/**
 * 获取系统信息。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSystemInfo({
 *       success: function(res) {
 *         console.log(res.model)
 *         console.log(res.pixelRatio)
 *         console.log(res.windowWidth)
 *         console.log(res.windowHeight)
 *         console.log(res.language)
 *         console.log(res.version)
 *         console.log(res.platform)
 *       }
 *     })
 *     ```
 * 
 */

exports.getSystemInfo = getSystemInfo;

(function (_getSystemInfo) {})(getSystemInfo || (exports.getSystemInfo = getSystemInfo = {}));

var getSystemInfoSync;
/**
 * 获取系统信息同步接口
 *
 * **示例代码：**
 *
 *     ```javascript
 *     try {
 *       var res = swan.getSystemInfoSync()
 *       console.log(res.model)
 *       console.log(res.pixelRatio)
 *       console.log(res.windowWidth)
 *       console.log(res.windowHeight)
 *       console.log(res.language)
 *       console.log(res.version)
 *       console.log(res.platform)
 *     } catch (e) {
 *       // Do something when catch error
 *     }
 *     ```
 * 
 */

exports.getSystemInfoSync = getSystemInfoSync;

(function (_getSystemInfoSync) {})(getSystemInfoSync || (exports.getSystemInfoSync = getSystemInfoSync = {}));

var onMemoryWarning;
/**
 * 
 *
 * 监听内存不足的告警事件，Android下有告警等级划分，只有LOW和CRITICAL会回调开发者；iOS无等级划分。
 *
 * **CALLBACK返回参数：**
 *
 *     ```
 *     TRIM_MEMORY_RUNNING_MODERATE = 5
 *     TRIM_MEMORY_RUNNING_LOW = 10
 *     TRIM_MEMORY_RUNNING_CRITICAL = 15
 *     ```
 *
 * **示例代码：**
 *
 *     ```
 *     swan.onMemoryWarning(export function () {
 *       console.log('onMemoryWarningReceive')
 *     })
 *     ```
 * 
 */

exports.onMemoryWarning = onMemoryWarning;

(function (_onMemoryWarning) {})(onMemoryWarning || (exports.onMemoryWarning = onMemoryWarning = {}));

var getNetworkType;
/**
 * 获取网络类型。
 *
 * **success返回参数说明：**
 *
 *     ```javascript
 *     swan.getNetworkType({
 *       success: function(res) {
 *         // 返回网络类型, 有效值：
 *         // wifi/2g/3g/4g/unknown(Android下不常见的网络类型)/none(无网络)
 *         var networkType = res.networkType
 *       }
 *     })
 *     ```
 * 
 */

exports.getNetworkType = getNetworkType;

(function (_getNetworkType) {})(getNetworkType || (exports.getNetworkType = getNetworkType = {}));

var onNetworkStatusChange;
/**
 * 
 *
 * 监听网络状态变化。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onNetworkStatusChange(function(res) {
 *       console.log(res.isConnected)
 *       console.log(res.networkType)
 *     })
 *     ```
 * 
 */

exports.onNetworkStatusChange = onNetworkStatusChange;

(function (_onNetworkStatusChange) {})(onNetworkStatusChange || (exports.onNetworkStatusChange = onNetworkStatusChange = {}));

var setScreenBrightness;
/**
 * 
 *
 * 设置屏幕亮度。
 * 
 */

exports.setScreenBrightness = setScreenBrightness;

(function (_setScreenBrightness) {})(setScreenBrightness || (exports.setScreenBrightness = setScreenBrightness = {}));

var getScreenBrightness;
/**
 * 
 *
 * 获取屏幕亮度。
 * 
 */

exports.getScreenBrightness = getScreenBrightness;

(function (_getScreenBrightness) {})(getScreenBrightness || (exports.getScreenBrightness = getScreenBrightness = {}));

var vibrateLong;
/**
 * 
 *
 * 使手机发生较长时间的振动（400ms）
 * 
 */

exports.vibrateLong = vibrateLong;

(function (_vibrateLong) {})(vibrateLong || (exports.vibrateLong = vibrateLong = {}));

var vibrateShort;
/**
 * 
 *
 * 使手机发生较短时间的振动（15ms）
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`：`vibrateShort` 接口仅在 iPhone7/iPhone7Plus 及 Android 机型生效
 * 2.  `tip`: `getScreenBrightness` 接口若安卓系统设置中开启了自动调节亮度功能，则屏幕亮度会根据光线自动调整，该接口仅能获取自动调节亮度之前的值，而非实时的亮度值。
 * 
 */

exports.vibrateShort = vibrateShort;

(function (_vibrateShort) {})(vibrateShort || (exports.vibrateShort = vibrateShort = {}));

var onAccelerometerChange;
/**
 * 监听加速度数据，频率：5次/秒，接口调用后会自动开始监听，可使用 `swan.stopAccelerometer` 停止监听。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onAccelerometerChange(function(res) {
 *       console.log(res.x)
 *       console.log(res.y)
 *       console.log(res.z)
 *     })
 *     ```
 * 
 */

exports.onAccelerometerChange = onAccelerometerChange;

(function (_onAccelerometerChange) {})(onAccelerometerChange || (exports.onAccelerometerChange = onAccelerometerChange = {}));

var startAccelerometer;
/**
 * 
 *
 * 开始监听加速度数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startAccelerometer({
 *         interval: 'game'
 *     })
 *     ```
 * 
 */

exports.startAccelerometer = startAccelerometer;

(function (_startAccelerometer) {})(startAccelerometer || (exports.startAccelerometer = startAccelerometer = {}));

var stopAccelerometer;
/**
 * 
 *
 * 停止监听加速度数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopAccelerometer()
 *     ```
 * 
 */

exports.stopAccelerometer = stopAccelerometer;

(function (_stopAccelerometer) {})(stopAccelerometer || (exports.stopAccelerometer = stopAccelerometer = {}));

var onCompassChange;
/**
 * 监听罗盘数据，频率：5次/秒，接口调用后会自动开始监听，可使用`swan.stopCompass`停止监听。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onCompassChange(export function (res) {
 *       console.log(res.direction)
 *     })
 *     ```
 * 
 */

exports.onCompassChange = onCompassChange;

(function (_onCompassChange) {})(onCompassChange || (exports.onCompassChange = onCompassChange = {}));

var startCompass;
/**
 * 
 *
 * 开始监听罗盘数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startCompass()
 *     ```
 * 
 */

exports.startCompass = startCompass;

(function (_startCompass) {})(startCompass || (exports.startCompass = startCompass = {}));

var stopCompass;
/**
 * 
 *
 * 停止监听罗盘数据。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopCompass()
 *     ```
 * 
 */

exports.stopCompass = stopCompass;

(function (_stopCompass) {})(stopCompass || (exports.stopCompass = stopCompass = {}));

var makePhoneCall;
/**
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.makePhoneCall({
 *       phoneNumber: '1340000' //仅为示例，并非真实的电话号码
 *     })
 *     ```
 * 
 */

exports.makePhoneCall = makePhoneCall;

(function (_makePhoneCall) {})(makePhoneCall || (exports.makePhoneCall = makePhoneCall = {}));

var scanCode;
/**
 * 调起客户端扫码界面，扫码成功后返回对应的结果
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 允许从相机和相册扫码
 *     swan.scanCode({
 *       success: (res) => {
 *         console.log(res)
 *       }
 *     })
 *
 *     // 只允许从相机扫码
 *     swan.scanCode({
 *       onlyFromCamera: true,
 *       success: (res) => {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.scanCode = scanCode;

(function (_scanCode) {})(scanCode || (exports.scanCode = scanCode = {}));

var setClipboardData;
/**
 * 
 *
 * 设置系统剪贴板的内容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setClipboardData({
 *       data: 'data',
 *       success: function(res) {
 *         swan.getClipboardData({
 *           success: function(res) {
 *             console.log(res.data) // data
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.setClipboardData = setClipboardData;

(function (_setClipboardData) {})(setClipboardData || (exports.setClipboardData = setClipboardData = {}));

var getClipboardData;
/**
 * 
 *
 * 获取系统剪贴板内容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getClipboardData({
 *       success: function(res){
 *         console.log(res.data)
 *       }
 *     })
 *     ```
 * 
 */

exports.getClipboardData = getClipboardData;

(function (_getClipboardData) {})(getClipboardData || (exports.getClipboardData = getClipboardData = {}));

var openBluetoothAdapter;
/**
 * 
 *
 * 初始化小程序蓝牙模块，生效周期为调用`swan.openBluetoothAdapter`至调用`swan.closeBluetoothAdapter`或小程序被销毁为止。 在小程序蓝牙适配器模块生效期间，开发者可以正常调用下面的小程序API，并会收到蓝牙模块相关的on回调。
 *
 * **Bug & Tip：**
 *
 * 2.  `tip`: 在没有调用`swan.openBluetoothAdapter`的情况下调用小程序其它蓝牙模块相关API，API会返回错误，错误码为`10000`
 * 3.  `bug`: 在用户蓝牙开关未开启或者手机不支持蓝牙功能的情况下，调用`swan.openBluetoothAdapter`会返回错误，错误码为`10001`，表示手机蓝牙功能不可用；此时小程序蓝牙模块已经初始化完成，可通过`swan.onBluetoothAdapterStateChange`监听手机蓝牙状态的改变，也可以调用蓝牙模块的所有API。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.openBluetoothAdapter({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.openBluetoothAdapter = openBluetoothAdapter;

(function (_openBluetoothAdapter) {})(openBluetoothAdapter || (exports.openBluetoothAdapter = openBluetoothAdapter = {}));

var closeBluetoothAdapter;
/**
 * 
 *
 * 关闭蓝牙模块，使其进入未初始化状态。调用该方法将断开所有已建立的链接并释放系统资源。建议在使用小程序蓝牙流程后调用，与`swan.openBluetoothAdapter`成对调用。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.closeBluetoothAdapter({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.closeBluetoothAdapter = closeBluetoothAdapter;

(function (_closeBluetoothAdapter) {})(closeBluetoothAdapter || (exports.closeBluetoothAdapter = closeBluetoothAdapter = {}));

var getBluetoothAdapterState;
/**
 * 
 *
 * 获取本机蓝牙适配器状态
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBluetoothAdapterState({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.getBluetoothAdapterState = getBluetoothAdapterState;

(function (_getBluetoothAdapterState) {})(getBluetoothAdapterState || (exports.getBluetoothAdapterState = getBluetoothAdapterState = {}));

var onBluetoothAdapterStateChange;
/**
 * 
 *
 * 监听蓝牙适配器状态变化事件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onBluetoothAdapterStateChange(function(res) {
 *       console.log(`adapterState changed, now is`, res)
 *     })
 *     ```
 * 
 */

exports.onBluetoothAdapterStateChange = onBluetoothAdapterStateChange;

(function (_onBluetoothAdapterStateChange) {})(onBluetoothAdapterStateChange || (exports.onBluetoothAdapterStateChange = onBluetoothAdapterStateChange = {}));

var startBluetoothDevicesDiscovery;
/**
 * 
 *
 * 开始搜寻附近的蓝牙外围设备。注意，该操作比较耗费系统资源，请在搜索并连接到设备后调用 stop 方法停止搜索。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 以硬件平台的蓝牙智能灯为例，主服务的 UUID 是 FEE7。传入这个参数，只搜索主服务 UUID 为 FEE7 的设备
 *     swan.startBluetoothDevicesDiscovery({
 *       services: ['FEE7'],
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.startBluetoothDevicesDiscovery = startBluetoothDevicesDiscovery;

(function (_startBluetoothDevicesDiscovery) {})(startBluetoothDevicesDiscovery || (exports.startBluetoothDevicesDiscovery = startBluetoothDevicesDiscovery = {}));

var stopBluetoothDevicesDiscovery;
/**
 * 
 *
 * 停止搜寻附近的蓝牙外围设备。若已经找到需要的蓝牙设备并不需要继续搜索时，建议调用该接口停止蓝牙搜索。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopBluetoothDevicesDiscovery({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.stopBluetoothDevicesDiscovery = stopBluetoothDevicesDiscovery;

(function (_stopBluetoothDevicesDiscovery) {})(stopBluetoothDevicesDiscovery || (exports.stopBluetoothDevicesDiscovery = stopBluetoothDevicesDiscovery = {}));

var getBluetoothDevices;
/**
 * 
 *
 * 获取在小程序蓝牙模块生效期间所有已发现的蓝牙设备，包括已经和本机处于连接状态的设备。
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: Mac系统可能无法获取`advertisData`及`RSSI`，请使用真机调试
 * 2.  `tip`: 开发者工具和 Android 上获取到的`deviceId`为设备 MAC 地址，iOS 上则为设备 uuid。因此`deviceId`不能硬编码到代码中
 * 3.  `tip`: 注意该接口获取到的设备列表为**小程序蓝牙模块生效期间所有搜索到的蓝牙设备**，若在蓝牙模块使用流程结束后未及时调用 swan.closeBluetoothAdapter 释放资源，会存在调用该接口会返回之前的蓝牙使用流程中搜索到的蓝牙设备，可能设备已经不在用户身边，无法连接。
 * 4.  `tips`: 蓝牙设备在被搜索到时，系统返回的 name 字段一般为广播包中的LocalName字段中的设备名称，而如果与蓝牙设备建立连接，系统返回的 name 字段会改为从蓝牙设备上获取到的GattName。若需要动态改变设备名称并展示，建议使用localName字段。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // ArrayBuffer转16进度字符串示例
 *     export function ab2hex(buffer) {
 *       var hexArr = Array.protoexport type.map.call(
 *         new Uint8Array(buffer),
 *         function(bit) {
 *           return ('00' + bit.toString(16)).slice(-2)
 *         }
 *       )
 *       return hexArr.join('');
 *     }
 *     swan.getBluetoothDevices({
 *       success: export function (res) {
 *         console.log(res)
 *         if (res.devices[0]) {
 *           console.log(ab2hex(res.devices[0].advertisData))
 *         }
 *       }
 *     })
 *     ```
 * 
 */

exports.getBluetoothDevices = getBluetoothDevices;

(function (_getBluetoothDevices) {})(getBluetoothDevices || (exports.getBluetoothDevices = getBluetoothDevices = {}));

var onBluetoothDeviceFound;
/**
 * 
 *
 * 监听寻找到新设备的事件
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: Mac系统可能无法获取`advertisData`及`RSSI`，请使用真机调试
 * 2.  `tip`: 开发者工具和 Android 上获取到的`deviceId`为设备 MAC 地址，iOS 上则为设备 uuid。因此`deviceId`不能硬编码到代码中
 * 3.  `tip`: 若在onBluetoothDeviceFound回调了某个设备，则此设备会添加到 swan.getBluetoothDevices 接口获取到的数组中
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // ArrayBuffer转16进度字符串示例
 *     export function ab2hex(buffer) {
 *       var hexArr = Array.protoexport type.map.call(
 *         new Uint8Array(buffer),
 *         function(bit) {
 *           return ('00' + bit.toString(16)).slice(-2)
 *         }
 *       )
 *       return hexArr.join('');
 *     }
 *     swan.onBluetoothDeviceFound(function(devices) {
 *       console.log('new device list has founded')
 *       console.dir(devices)
 *       console.log(ab2hex(devices[0].advertisData))
 *     })
 *     ```
 * 
 */

exports.onBluetoothDeviceFound = onBluetoothDeviceFound;

(function (_onBluetoothDeviceFound) {})(onBluetoothDeviceFound || (exports.onBluetoothDeviceFound = onBluetoothDeviceFound = {}));

var getConnectedBluetoothDevices;
/**
 * 
 *
 * 根据 uuid 获取处于已连接状态的设备
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 开发者工具和 Android 上获取到的`deviceId`为设备 MAC 地址，iOS 上则为设备 uuid。因此`deviceId`不能硬编码到代码中
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getConnectedBluetoothDevices({
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.getConnectedBluetoothDevices = getConnectedBluetoothDevices;

(function (_getConnectedBluetoothDevices) {})(getConnectedBluetoothDevices || (exports.getConnectedBluetoothDevices = getConnectedBluetoothDevices = {}));

var createBLEConnection;
/**
 * 
 *
 * 连接低功耗蓝牙设备。
 *
 * > 若小程序在之前已有搜索过某个蓝牙设备，并成功建立链接，可直接传入之前搜索获取的deviceId直接尝试连接该设备，无需进行搜索操作。
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 安卓手机上如果多次调用create创建连接，有可能导致系统持有同一设备多个连接的实例，导致调用close的时候并不能真正的断开与设备的连接。因此请保证尽量成对的调用create和close接口
 * 2.  `tip`: 蓝牙链接随时可能断开，建议监听 swan.onBLEConnectionStateChange 回调事件，当蓝牙设备断开时按需执行重连操作
 * 3.  `tip`: 若对未连接的设备或已断开连接的设备调用数据读写操作的接口，会返回10006错误，详见错误码，建议进行重连操作
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.createBLEConnection({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接 
 *       deviceId: deviceId,
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.createBLEConnection = createBLEConnection;

(function (_createBLEConnection) {})(createBLEConnection || (exports.createBLEConnection = createBLEConnection = {}));

var closeBLEConnection;
/**
 * 
 *
 * 断开与低功耗蓝牙设备的连接
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.closeBLEConnection({
 *       deviceId:deviceId
 *       success: export function (res) {
 *         console.log(res)
 *       }
 *     })
 *     ```
 * 
 */

exports.closeBLEConnection = closeBLEConnection;

(function (_closeBLEConnection) {})(closeBLEConnection || (exports.closeBLEConnection = closeBLEConnection = {}));

var onBLEConnectionStateChange;
/**
 * 
 *
 * 监听低功耗蓝牙连接状态的改变事件，包括开发者主动连接或断开连接，设备丢失，连接异常断开等等
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onBLEConnectionStateChange(function(res) {
 *       // 该方法回调中可以用于处理连接意外断开等异常情况
 *       console.log(`device ${res.deviceId} state has changed, connected: ${res.connected}`)
 *     })
 *     ```
 * 
 */

exports.onBLEConnectionStateChange = onBLEConnectionStateChange;

(function (_onBLEConnectionStateChange) {})(onBLEConnectionStateChange || (exports.onBLEConnectionStateChange = onBLEConnectionStateChange = {}));

var getBLEDeviceServices;
/**
 * 
 *
 * 获取蓝牙设备所有 service（服务）
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`:iOS平台上后续对特征值的read、write、notify，由于系统需要获取特征值实例，传入的 serviceId 与 characteristicId 必须由 getBLEDeviceServices 与 getBLEDeviceCharacteristics 中获取到后才能使用。建议双平台统一在建立链接后先执行 getBLEDeviceServices 与 getBLEDeviceCharacteristics 后再进行与蓝牙设备的数据交互
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBLEDeviceServices({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接 
 *       deviceId: deviceId,
 *       success: export function (res) {
 *         console.log('device services:', res.services)
 *       }
 *     })
 *     ```
 * 
 */

exports.getBLEDeviceServices = getBLEDeviceServices;

(function (_getBLEDeviceServices) {})(getBLEDeviceServices || (exports.getBLEDeviceServices = getBLEDeviceServices = {}));

var getBLEDeviceCharacteristics;
/**
 * 
 *
 * 获取蓝牙设备某个服务中的所有 characteristic（特征值）
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`:传入的serviceId需要在getBLEDeviceServices获取到
 * 2.  `tip`:iOS平台上后续对特征值的read、write、notify，由于系统需要获取特征值实例，传入的 serviceId 与 characteristicId 必须由 getBLEDeviceServices 与 getBLEDeviceCharacteristics 中获取到后才能使用。建议双平台统一在建立链接后先执行 getBLEDeviceServices 与 getBLEDeviceCharacteristics 后再进行与蓝牙设备的数据交互
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getBLEDeviceCharacteristics({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       success: export function (res) {
 *         console.log('device getBLEDeviceCharacteristics:', res.characteristics)
 *       }
 *     })
 *     ```
 * 
 */

exports.getBLEDeviceCharacteristics = getBLEDeviceCharacteristics;

(function (_getBLEDeviceCharacteristics) {})(getBLEDeviceCharacteristics || (exports.getBLEDeviceCharacteristics = getBLEDeviceCharacteristics = {}));

var readBLECharacteristicValue;
/**
 * 
 *
 * 读取低功耗蓝牙设备的特征值的二进制数据值。注意：必须设备的特征值支持`read`才可以成功调用，具体参照 characteristic 的 properties 属性
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 并行调用多次读写接口存在读写失败的可能性。
 * 2.  `tip`: `read`接口读取到的信息需要在`onBLECharacteristicValueChange`方法注册的回调中获取。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 必须在这里的回调才能获取
 *     swan.onBLECharacteristicValueChange(function(characteristic) {
 *       console.log('characteristic value comed:', characteristic)
 *     })
 *
 *     swan.readBLECharacteristicValue({
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接  [**new**]
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       // 这里的 characteristicId 需要在上面的 getBLEDeviceCharacteristics 接口中获取
 *       characteristicId: characteristicId,
 *       success: export function (res) {
 *         console.log('readBLECharacteristicValue:', res.errCode)
 *       }
 *     })
 *     ```
 * 
 */

exports.readBLECharacteristicValue = readBLECharacteristicValue;

(function (_readBLECharacteristicValue) {})(readBLECharacteristicValue || (exports.readBLECharacteristicValue = readBLECharacteristicValue = {}));

var writeBLECharacteristicValue;
/**
 * 
 *
 * 向低功耗蓝牙设备特征值中写入二进制数据。注意：必须设备的特征值支持`write`才可以成功调用，具体参照 characteristic 的 properties 属性
 *
 * _tips: 并行调用多次读写接口存在读写失败的可能性_
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 并行调用多次读写接口存在读写失败的可能性。
 * 2.  `tip`: 小程序不会对写入数据包大小做限制，但系统与蓝牙设备会确定蓝牙4.0单次传输的数据大小，超过最大字节数后会发生写入错误，建议每次写入不超过20字节。
 * 3.  `tip`: 安卓平台上，在调用notify成功后立即调用write接口，在部分机型上会发生 10008 系统错误
 * 4.  `bug`: 若单次写入数据过长，iOS平台上存在系统不会有任何回调的情况(包括错误回调)。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 向蓝牙设备发送一个0x00的16进制数据
 *     let buffer = new ArrayBuffer(1)
 *     let dataView = new DataView(buffer)
 *     dataView.setUint8(0, 0)
 *
 *     swan.writeBLECharacteristicValue({
 *       // 这里的 deviceId 需要在上面的 getBluetoothDevices 或 onBluetoothDeviceFound 接口中获取
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       // 这里的 characteristicId 需要在上面的 getBLEDeviceCharacteristics 接口中获取
 *       characteristicId: characteristicId,
 *       // 这里的value是ArrayBuffer类型
 *       value: buffer,
 *       success: export function (res) {
 *         console.log('writeBLECharacteristicValue success', res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.writeBLECharacteristicValue = writeBLECharacteristicValue;

(function (_writeBLECharacteristicValue) {})(writeBLECharacteristicValue || (exports.writeBLECharacteristicValue = writeBLECharacteristicValue = {}));

var notifyBLECharacteristicValueChange;
/**
 * 
 *
 * 启用低功耗蓝牙设备特征值变化时的 notify 功能，订阅特征值。注意：必须设备的特征值支持`notify`或者`indicate`才可以成功调用，具体参照 characteristic 的 properties 属性
 *
 * 另外，必须先启用`notify`才能监听到设备 characteristicValueChange 事件
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 订阅操作成功后需要设备主动更新特征值的value，才会触发 swan.onBLECharacteristicValueChange 回调。
 * 2.  `tip`: 安卓平台上，在调用notify成功后立即调用write接口，在部分机型上会发生 10008 系统错误
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.notifyBLECharacteristicValueChange({
 *       state: true, // 启用 notify 功能
 *       // 这里的 deviceId 需要已经通过 createBLEConnection 与对应设备建立链接  
 *       deviceId: deviceId,
 *       // 这里的 serviceId 需要在上面的 getBLEDeviceServices 接口中获取
 *       serviceId: serviceId,
 *       // 这里的 characteristicId 需要在上面的 getBLEDeviceCharacteristics 接口中获取
 *       characteristicId: characteristicId,
 *       success: export function (res) {
 *         console.log('notifyBLECharacteristicValueChange success', res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.notifyBLECharacteristicValueChange = notifyBLECharacteristicValueChange;

(function (_notifyBLECharacteristicValueChange) {})(notifyBLECharacteristicValueChange || (exports.notifyBLECharacteristicValueChange = notifyBLECharacteristicValueChange = {}));

var onBLECharacteristicValueChange;
/**
 * 
 *
 * 监听低功耗蓝牙设备的特征值变化。必须先启用`notify`接口才能接收到设备推送的notification。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // ArrayBuffer转16进度字符串示例
 *     export function ab2hex(buffer) {
 *       var hexArr = Array.protoexport type.map.call(
 *         new Uint8Array(buffer),
 *         function(bit) {
 *           return ('00' + bit.toString(16)).slice(-2)
 *         }
 *       )
 *       return hexArr.join('');
 *     }
 *     swan.onBLECharacteristicValueChange(function(res) {
 *       console.log(`characteristic ${res.characteristicId} has changed, now is ${res.value}`)
 *       console.log(ab2hext(res.value))
 *     })
 *     ```
 * 
 */

exports.onBLECharacteristicValueChange = onBLECharacteristicValueChange;

(function (_onBLECharacteristicValueChange) {})(onBLECharacteristicValueChange || (exports.onBLECharacteristicValueChange = onBLECharacteristicValueChange = {}));

var startBeaconDiscovery;
/**
 * 
 *
 * 开始搜索附近的`iBeacon`设备
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startBeaconDiscovery({
 *         success(res) {
 *         }
 *     })
 *     ```
 * 
 */

exports.startBeaconDiscovery = startBeaconDiscovery;

(function (_startBeaconDiscovery) {})(startBeaconDiscovery || (exports.startBeaconDiscovery = startBeaconDiscovery = {}));

var stopBeaconDiscovery;
/**
 * 
 *
 * 停止搜索附近的`iBeacon`设备
 * 
 */

exports.stopBeaconDiscovery = stopBeaconDiscovery;

(function (_stopBeaconDiscovery) {})(stopBeaconDiscovery || (exports.stopBeaconDiscovery = stopBeaconDiscovery = {}));

var getBeacons;
/**
 * 
 *
 * 获取所有已搜索到的`iBeacon`设备
 * 
 */

exports.getBeacons = getBeacons;

(function (_getBeacons) {})(getBeacons || (exports.getBeacons = getBeacons = {}));

var onBeaconUpdate;
/**
 * 
 *
 * 监听 `iBeacon` 设备的更新事件
 * 
 */

exports.onBeaconUpdate = onBeaconUpdate;

(function (_onBeaconUpdate) {})(onBeaconUpdate || (exports.onBeaconUpdate = onBeaconUpdate = {}));

var onBeaconServiceChange;
/**
 * 
 *
 * 监听 `iBeacon` 服务的状态变化
 * 
 */

exports.onBeaconServiceChange = onBeaconServiceChange;

(function (_onBeaconServiceChange) {})(onBeaconServiceChange || (exports.onBeaconServiceChange = onBeaconServiceChange = {}));

var setKeepScreenOn;
/**
 * 
 *
 * 设置是否保持常亮状态。仅在当前小程序生效，离开小程序后设置失效。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 保持屏幕常亮
 *     swan.setKeepScreenOn({
 *         keepScreenOn: true
 *     })
 *     ```
 * 
 */

exports.setKeepScreenOn = setKeepScreenOn;

(function (_setKeepScreenOn) {})(setKeepScreenOn || (exports.setKeepScreenOn = setKeepScreenOn = {}));

var addPhoneContact;
/**
 * 
 *
 * 调用后，用户可以选择将该表单以“新增联系人”或“添加到已有联系人”的方式，写入手机系统通讯录，完成手机通讯录联系人和联系方式的增加。
 *
 * **回调结果：**
 *
 *   回调类型  |  errMsg           |  说明                 
 * ------------|-------------------|-----------------------
 *   success   |  ok               |  添加成功             
 *   fail      |  fail cancel      |  用户取消操作         
 *   fail      |  fail ${detail}   |调用失败，detail 加上详细信息
 * 
 */

exports.addPhoneContact = addPhoneContact;

(function (_addPhoneContact) {})(addPhoneContact || (exports.addPhoneContact = addPhoneContact = {}));

var getHCEState;
/**
 * 
 *
 * 判断当前设备是否支持 HCE 能力。
 *
 * **success返回参数说明：**
 *
 *     ```javascript
 *     swan.getHCEState({
 *       success: function(res) {
 *         console.log(res.errCode)
 *       }
 *     })
 *     ```
 * 
 */

exports.getHCEState = getHCEState;

(function (_getHCEState) {})(getHCEState || (exports.getHCEState = getHCEState = {}));

var startHCE;
/**
 * 
 *
 * 初始化 NFC 模块。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startHCE({
 *       aid_list: ['F222222222']
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.startHCE = startHCE;

(function (_startHCE) {})(startHCE || (exports.startHCE = startHCE = {}));

var stopHCE;
/**
 * 
 *
 * 关闭 NFC 模块。仅在安卓系统下有效。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopHCE({
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.stopHCE = stopHCE;

(function (_stopHCE) {})(stopHCE || (exports.stopHCE = stopHCE = {}));

var onHCEMessage;
/**
 * 
 *
 * 监听 NFC 设备的消息回调，并在回调中处理。返回参数中 `messageType` 表示消息类型，目前有如下值：
 *
 * *   1：消息为HCE Apdu Command类型，小程序需对此指令进行处理，并调用 `sendHCEMessage` 接口返回处理指令；
 * *   2：消息为设备离场事件
 * 
 */

exports.onHCEMessage = onHCEMessage;

(function (_onHCEMessage) {})(onHCEMessage || (exports.onHCEMessage = onHCEMessage = {}));

var sendHCEMessage;
/**
 * 
 *
 * 发送 NFC 消息。仅在安卓系统下有效。
 *
 * **success返回参数说明：**
 *
 *     ```javascript
 *     const buffer = new ArrayBuffer(1)
 *     const dataView = new DataView(buffer)
 *     dataView.setUint8(0, 0)
 *
 *     swan.startHCE({
 *       success: function(res) {
 *         swan.onHCEMessage(function(res) {
 *           if (res.messageType === 1) {
 *             swan.sendHCEMessage({data: buffer})
 *           }
 *         })
 *       }
 *     })
 *     ```
 * 
 */

exports.sendHCEMessage = sendHCEMessage;

(function (_sendHCEMessage) {})(sendHCEMessage || (exports.sendHCEMessage = sendHCEMessage = {}));

var startWifi;
/**
 * 
 *
 * 初始化 Wi-Fi 模块。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startWifi({
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.startWifi = startWifi;

(function (_startWifi) {})(startWifi || (exports.startWifi = startWifi = {}));

var stopWifi;
/**
 * 
 *
 * 关闭 Wi-Fi 模块。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.stopWifi({
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.stopWifi = stopWifi;

(function (_stopWifi) {})(stopWifi || (exports.stopWifi = stopWifi = {}));

var connectWifi;
/**
 * 
 *
 * 连接 Wi-Fi。若已知 Wi-Fi 信息，可以直接利用该接口连接。仅 Android 与 iOS 11 以上版本支持。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.connectWifi({
 *       SSID: '',
 *       BSSID: '',
 *       success: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.connectWifi = connectWifi;

(function (_connectWifi) {})(connectWifi || (exports.connectWifi = connectWifi = {}));

var getWifiList;
/**
 * 
 *
 * 请求获取 Wi-Fi 列表，在 `onGetWifiList` 注册的回调中返回 wifiList 数据。iOS 将跳转到系统的 Wi-Fi 界面，Android 不会跳转。 **iOS 11.0 及 iOS 11.1 两个版本因系统问题，该方法失效。但在 iOS 11.2 中已修复。**
 * 
 */

exports.getWifiList = getWifiList;

(function (_getWifiList) {})(getWifiList || (exports.getWifiList = getWifiList = {}));

var onGetWifiList;
/**
 * 
 *
 * 监听在获取到 Wi-Fi 列表数据时的事件，在回调中将返回 wifiList。
 * 
 */

exports.onGetWifiList = onGetWifiList;

(function (_onGetWifiList) {})(onGetWifiList || (exports.onGetWifiList = onGetWifiList = {}));

var setWifiList;
/**
 * 
 *
 * **iOS特有接口** 在 `onGetWifiList` 回调后，利用接口设置 wifiList 中 AP 的相关信息。
 *
 * 注意：
 *
 * 1.  该接口只能在 `onGetWifiList` 回调之后才能调用。
 * 2.  此时客户端会挂起，等待小程序设置 Wi-Fi 信息，请务必尽快调用该接口，若无数据请传入一个空数组。
 * 3.  有可能随着周边 Wi-Fi 列表的刷新，单个流程内收到多次带有存在重复的 Wi-Fi 列表的回调。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.onGetWifiList(function(res) {
 *       if (res.wifiList.length) {
 *         swan.setWifiList({
 *           wifiList: [{
 *             SSID: res.wifiList[0].SSID,
 *             BSSID: res.wifiList[0].BSSID,
 *             password: '123456'
 *           }]
 *         })
 *       } else {
 *         swan.setWifiList({
 *           wifiList: []
 *         })
 *       }
 *     })
 *     swan.getWifiList()
 *     ```
 * 
 */

exports.setWifiList = setWifiList;

(function (_setWifiList) {})(setWifiList || (exports.setWifiList = setWifiList = {}));

var onWifiConnected;
/**
 * 
 *
 * 监听连接上 Wi-Fi 的事件。
 * 
 */

exports.onWifiConnected = onWifiConnected;

(function (_onWifiConnected) {})(onWifiConnected || (exports.onWifiConnected = onWifiConnected = {}));

var getConnectedWifi;
/**
 * 
 *
 * 获取已连接中的 Wi-Fi 信息
 *
 * **errCode列表：**
 *
 * 每个接口调用的时候，都会返回 `errCode` 字段。
 *
 *   错误码  |  说明                    |  备注                        
 * ----------|--------------------------|------------------------------
 *   0       |  ok                      |  正常                        
 *   12000   |  not init                |  未先调用startWifi接口       
 *   12001   |  system not support      |  当前系统不支持相关能力      
 *   12002   |  password error          |  Wi-Fi 密码错误              
 *   12003   |  connection timeout      |  连接超时                    
 *   12004   |  duplicate request       |  重复连接 Wi-Fi              
 *   12005   |  wifi not turned on      |Android特有，未打开 Wi-Fi 开关
 *   12006   |  gps not turned on       |Android特有，未打开 GPS 定位开关
 *   12007   |  user denied             |  用户拒绝授权链接 Wi-Fi      
 *   12008   |  invalid SSID            |  无效SSID                    
 *   12009   |  system config err       | 系统运营商配置拒绝连接 Wi-Fi 
 *   12010   |  system internal error   |系统其他错误，需要在errmsg打印具体的错误原因
 *   12011   |  weapp in background     |  应用在后台无法配置 Wi-Fi    
 * 
 */

exports.getConnectedWifi = getConnectedWifi;

(function (_getConnectedWifi) {})(getConnectedWifi || (exports.getConnectedWifi = getConnectedWifi = {}));

var showToast;
/**
 * 显示消息提示框
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showToast({
 *       title: '成功',
 *       icon: 'success',
 *       duration: 2000
 *     })
 *     ```
 * 
 */

exports.showToast = showToast;

(function (_showToast) {})(showToast || (exports.showToast = showToast = {}));

var showLoading;
/**
 * 
 *
 * 显示 loading 提示框, 需主动调用 swan.hideLoading才能关闭提示框
 * 
 */

exports.showLoading = showLoading;

(function (_showLoading) {})(showLoading || (exports.showLoading = showLoading = {}));

var hideToast;
/**
 * 隐藏消息提示框
 */

exports.hideToast = hideToast;

(function (_hideToast) {})(hideToast || (exports.hideToast = hideToast = {}));

var hideLoading;
/**
 * 隐藏 loading 提示框
 *
 * **示例：**
 *
 * ```javascript
 * swan.showLoading({
 *   title: '加载中',
 * })
 *
 * setTimeout(function(){
 *   swan.hideLoading()
 * }, 2000)
 * ```
 */

exports.hideLoading = hideLoading;

(function (_hideLoading) {})(hideLoading || (exports.hideLoading = hideLoading = {}));

var showModal;
/**
 * 显示模态框
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showModal({
 *       title: '提示',
 *       content: '这是一个模态弹窗',
 *       success: function(res) {
 *         if (res.confirm) {
 *           console.log('用户点击确定')
 *         } else if (res.cancel) {
 *           console.log('用户点击取消')
 *         }
 *       }
 *     })
 *     ```
 * 
 */

exports.showModal = showModal;

(function (_showModal) {})(showModal || (exports.showModal = showModal = {}));

var showActionSheet;
/**
 * 显示操作菜单
 *
 * **Bug & Tip：**
 *
 * 1.  `bug`: `Android` `6.3.30`，swan.showModal 的返回的 confirm 一直为 true；
 * 2.  `tip`: swan.showActionSheet 点击取消或蒙层时，回调 `fail`, errMsg 为 "showActionSheet:fail cancel"；
 * 3.  `tip`: swan.showLoading 和 swan.showToast 同时只能显示一个，但 swan.hideToast/swan.hideLoading 也应当配对使用；
 * 4.  `tip`: `iOS` swan.showModal 点击蒙层不会关闭模态弹窗，所以尽量避免使用“取消”分支中实现业务逻辑。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showActionSheet({
 *       itemList: ['A', 'B', 'C'],
 *       success: function(res) {
 *         console.log(res.tapIndex)
 *       },
 *       fail: function(res) {
 *         console.log(res.errMsg)
 *       }
 *     })
 *     ```
 * 
 */

exports.showActionSheet = showActionSheet;

(function (_showActionSheet) {})(showActionSheet || (exports.showActionSheet = showActionSheet = {}));

var setTopBarText;
/**
 * 
 *
 * 动态设置置顶栏文字内容，只有当前小程序被置顶时能生效，如果当前小程序没有被置顶，也能调用成功，但是不会立即生效，只有在用户将这个小程序置顶后才换上设置的文字内容。**注意：调用成功后，需间隔 5s 才能再次调用此接口，如果在 5s 内再次调用此接口，会回调 fail，errMsg："setTopBarText: fail invoke too frequently"**
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTopBarText({
 *       text: 'hello, world!'
 *     })
 *     ```
 * 
 */

exports.setTopBarText = setTopBarText;

(function (_setTopBarText) {})(setTopBarText || (exports.setTopBarText = setTopBarText = {}));

var setNavigationBarTitle;
/**
 * 动态设置当前页面的标题。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setNavigationBarTitle({
 *       title: '当前页面'
 *     })
 *     ```
 * 
 */

exports.setNavigationBarTitle = setNavigationBarTitle;

(function (_setNavigationBarTitle) {})(setNavigationBarTitle || (exports.setNavigationBarTitle = setNavigationBarTitle = {}));

var setNavigationBarColor;
/**
 * 
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setNavigationBarColor({
 *         frontColor: '#ffffff',
 *         backgroundColor: '#ff0000',
 *         animation: {
 *             duration: 400,
 *             timingFunc: 'easeIn'
 *         }
 *     })
 *     ```
 * 
 */

exports.setNavigationBarColor = setNavigationBarColor;

(function (_setNavigationBarColor) {})(setNavigationBarColor || (exports.setNavigationBarColor = setNavigationBarColor = {}));

var setTabBarBadge;
/**
 * 
 *
 * 为 tabBar 某一项的右上角添加文本
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTabBarBadge({
 *       index: 0,
 *       text: '1'
 *     })
 *     ```
 * 
 */

exports.setTabBarBadge = setTabBarBadge;

(function (_setTabBarBadge) {})(setTabBarBadge || (exports.setTabBarBadge = setTabBarBadge = {}));

var removeTabBarBadge;
/**
 * 
 *
 * 移除 tabBar 某一项右上角的文本
 * 
 */

exports.removeTabBarBadge = removeTabBarBadge;

(function (_removeTabBarBadge) {})(removeTabBarBadge || (exports.removeTabBarBadge = removeTabBarBadge = {}));

var showTabBarRedDot;
/**
 * 
 *
 * 显示 tabBar 某一项的右上角的红点
 * 
 */

exports.showTabBarRedDot = showTabBarRedDot;

(function (_showTabBarRedDot) {})(showTabBarRedDot || (exports.showTabBarRedDot = showTabBarRedDot = {}));

var hideTabBarRedDot;
/**
 * 
 *
 * 隐藏 tabBar 某一项的右上角的红点
 * 
 */

exports.hideTabBarRedDot = hideTabBarRedDot;

(function (_hideTabBarRedDot) {})(hideTabBarRedDot || (exports.hideTabBarRedDot = hideTabBarRedDot = {}));

var setTabBarStyle;
/**
 * 
 *
 * 动态设置 tabBar 的整体样式
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTabBarStyle({
 *         color: '#FF0000',
 *         selectedColor: '#00FF00',
 *         backgroundColor: '#0000FF',
 *         borderStyle: 'white'
 *     })
 *     ```
 * 
 */

exports.setTabBarStyle = setTabBarStyle;

(function (_setTabBarStyle) {})(setTabBarStyle || (exports.setTabBarStyle = setTabBarStyle = {}));

var setTabBarItem;
/**
 * 
 *
 * 动态设置 tabBar 某一项的内容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setTabBarItem({
 *         index: 0,
 *         text: 'text',
 *         iconPath: '/path/to/iconPath',
 *         selectedIconPath: '/path/to/selectedIconPath'
 *     })
 *     ```
 * 
 */

exports.setTabBarItem = setTabBarItem;

(function (_setTabBarItem) {})(setTabBarItem || (exports.setTabBarItem = setTabBarItem = {}));

var showTabBar;
/**
 * 
 *
 * 显示 tabBar
 * 
 */

exports.showTabBar = showTabBar;

(function (_showTabBar) {})(showTabBar || (exports.showTabBar = showTabBar = {}));

var hideTabBar;
/**
 * 
 *
 * 隐藏 tabBar
 * 
 */

exports.hideTabBar = hideTabBar;

(function (_hideTabBar) {})(hideTabBar || (exports.hideTabBar = hideTabBar = {}));

var setBackgroundColor;
/**
 * 
 *
 * 动态设置窗口的背景色
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setBackgroundColor({
 *         backgroundColor: '#ffffff', // 窗口的背景色为白色
 *     })
 *
 *     swan.setBackgroundColor({
 *         backgroundColorTop: '#ffffff', // 顶部窗口的背景色为白色
 *         backgroundColorBottom: '#ffffff', // 底部窗口的背景色为白色
 *     })
 *     ```
 * 
 */

exports.setBackgroundColor = setBackgroundColor;

(function (_setBackgroundColor) {})(setBackgroundColor || (exports.setBackgroundColor = setBackgroundColor = {}));

var setBackgroundTextStyle;
/**
 * 
 *
 * 动态设置下拉背景字体、loading 图的样式
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.setBackgroundTextStyle({
 *         textStyle: 'dark', // 下拉背景字体、loading 图的样式为dark
 *     })
 *     ```
 * 
 */

exports.setBackgroundTextStyle = setBackgroundTextStyle;

(function (_setBackgroundTextStyle) {})(setBackgroundTextStyle || (exports.setBackgroundTextStyle = setBackgroundTextStyle = {}));

var navigateTo;
/**
 * 保留当前页面，跳转到应用内的某个页面，使用`swan.navigateBack`可以返回到原页面。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.navigateTo({
 *       url: 'test?id=1'
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //test.js
 *     Page({
 *       onLoad: function(option){
 *         console.log(option.query)
 *       }
 *     })
 *     ```
 * 
 */

exports.navigateTo = navigateTo;

(function (_navigateTo) {})(navigateTo || (exports.navigateTo = navigateTo = {}));

var redirectTo;
/**
 * 关闭当前页面，跳转到应用内的某个页面。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.redirectTo({
 *       url: 'test?id=1'
 *     })
 *     ```
 * 
 */

exports.redirectTo = redirectTo;

(function (_redirectTo) {})(redirectTo || (exports.redirectTo = redirectTo = {}));

var reLaunch;
/**
 * 
 *
 * 关闭所有页面，打开到应用内的某个页面。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.reLaunch({
 *       url: 'test?id=1'
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //test.js
 *     Page({
 *       onLoad: function(option){
 *         console.log(option.query)
 *       }
 *     })
 *     ```
 * 
 */

exports.reLaunch = reLaunch;

(function (_reLaunch) {})(reLaunch || (exports.reLaunch = reLaunch = {}));

var switchTab;
/**
 * 跳转到 tabBar 页面，并关闭其他所有非 tabBar 页面
 *
 * **示例代码：**
 *
 *     ```json
 *     {
 *       "tabBar": {
 *         "list": [{
 *           "pagePath": "index",
 *           "text": "首页"
 *         },{
 *           "pagePath": "other",
 *           "text": "其他"
 *         }]
 *       }
 *     }
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.switchTab({
 *       url: '/index'
 *     })
 *     ```
 * 
 */

exports.switchTab = switchTab;

(function (_switchTab) {})(switchTab || (exports.switchTab = switchTab = {}));

var navigateBack;
/**
 * 关闭当前页面，返回上一页面或多级页面。可通过 `getCurrentPages()`获取当前的页面栈，决定需要返回几层。
 *
 * **Tip：**
 *
 * 1.  `tip`: swan.navigateTo 和 swan.redirectTo 不允许跳转到 tabbar 页面，只能用 swan.switchTab 跳转到 tabbar 页面
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 注意：调用 navigateTo 跳转时，调用该方法的页面会被加入堆栈，而 redirectTo 方法则不会。见下方示例代码
 *
 *     // 此处是A页面
 *     swan.navigateTo({
 *       url: 'B?id=1'
 *     })
 *
 *     // 此处是B页面
 *     swan.navigateTo({
 *       url: 'C?id=1'
 *     })
 *
 *     // 在C页面内 navigateBack，将返回A页面
 *     swan.navigateBack({
 *       delta: 2
 *     })
 *     ```
 * 
 */

exports.navigateBack = navigateBack;

(function (_navigateBack) {})(navigateBack || (exports.navigateBack = navigateBack = {}));

var createAnimation;
/**
 * 创建一个动画实例animation。调用实例的方法来描述动画。最后通过动画实例的`export`方法导出动画数据传递给组件的`animation`属性。
 *
 * **注意: `export` 方法每次调用后会清掉之前的动画操作**
 *
 * **timingFunction 有效值：**
 *
 *     ```javascript
 *     var animation = swan.createAnimation({
 *       transformOrigin: "50% 50%",
 *       duration: 1000,
 *       timingFunction: "ease",
 *       delay: 0
 *     })
 *     ```
 * 
 */

exports.createAnimation = createAnimation;

(function (_createAnimation) {})(createAnimation || (exports.createAnimation = createAnimation = {}));

var Animation = /*#__PURE__*/(0, _createClass2.default)(function Animation() {
  (0, _classCallCheck2.default)(this, Animation);
});
exports.Animation = Animation;
var pageScrollTo;
/**
 * 
 *
 * 将页面滚动到目标位置。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.pageScrollTo({
 *       scrollTop: 0,
 *       duration: 300
 *     })
 *     ```
 * 
 */

exports.pageScrollTo = pageScrollTo;

(function (_pageScrollTo) {})(pageScrollTo || (exports.pageScrollTo = pageScrollTo = {}));

var canvasToTempFilePath;
/**
 * 把当前画布指定区域的内容导出生成指定大小的图片，并返回文件路径。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 在 `draw` 回调里调用该方法才能保证图片导出成功。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.canvasToTempFilePath({
 *       x: 100,
 *       y: 200,
 *       width: 50,
 *       height: 50,
 *       destWidth: 100,
 *       destHeight: 100,
 *       canvasId: 'myCanvas',
 *       success: function(res) {
 *         console.log(res.tempFilePath)
 *       } 
 *     })
 *     ```
 * 
 */

exports.canvasToTempFilePath = canvasToTempFilePath;

(function (_canvasToTempFilePath) {})(canvasToTempFilePath || (exports.canvasToTempFilePath = canvasToTempFilePath = {}));

var canvasGetImageData;
/**
 * 
 *
 * 返回一个数组，用来描述 canvas 区域隐含的像素数据。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.canvasGetImageData({
 *       canvasId: 'myCanvas',
 *       x: 0,
 *       y: 0,
 *       width: 100,
 *       height: 100,
 *       success(res) {
 *         console.log(res.width) // 100
 *         console.log(res.height) // 100
 *         console.log(res.data instanceof Uint8ClampedArray) // true
 *         console.log(res.data.length) // 100 * 100 * 4
 *       }
 *     })
 *     ```
 * 
 */

exports.canvasGetImageData = canvasGetImageData;

(function (_canvasGetImageData) {})(canvasGetImageData || (exports.canvasGetImageData = canvasGetImageData = {}));

var canvasPutImageData;
/**
 * 
 *
 * 将像素数据绘制到画布的方法。在自定义组件下，第二个参数传入组件实例this，以操作组件内 `<canvas/>` 组件
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const data = new Uint8ClampedArray([255, 0, 0, 1])
 *     swan.canvasPutImageData({
 *       canvasId: 'myCanvas',
 *       x: 0,
 *       y: 0,
 *       width: 1,
 *       data: data,
 *       success(res) {}
 *     })
 *     ```
 * 
 */

exports.canvasPutImageData = canvasPutImageData;

(function (_canvasPutImageData) {})(canvasPutImageData || (exports.canvasPutImageData = canvasPutImageData = {}));

var startPullDownRefresh;
/**
 * 
 *
 * 开始下拉刷新，调用后触发下拉刷新动画，效果与用户手动下拉刷新一致
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startPullDownRefresh()
 *     ```
 * 
 */

exports.startPullDownRefresh = startPullDownRefresh;

(function (_startPullDownRefresh) {})(startPullDownRefresh || (exports.startPullDownRefresh = startPullDownRefresh = {}));

var SelectorQuery = /*#__PURE__*/(0, _createClass2.default)(function SelectorQuery() {
  (0, _classCallCheck2.default)(this, SelectorQuery);
});
exports.SelectorQuery = SelectorQuery;
var getExtConfig;
/**
 * 
 *
 * 获取第三方平台自定义的数据字段。
 *
 * **Bug & Tip：**
 *
 * 1.  `swan.getExtConfig` 暂时无法通过 `swan.canIUse` 判断是否兼容，开发者需要自行判断 `swan.getExtConfig` 是否存在来兼容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     if(swan.getExtConfig) {
 *       swan.getExtConfig({
 *         success: export function (res) {
 *           console.log(res.extConfig)
 *         }
 *       })
 *     }
 *     ```
 * 
 */

exports.getExtConfig = getExtConfig;

(function (_getExtConfig) {})(getExtConfig || (exports.getExtConfig = getExtConfig = {}));

var getExtConfigSync;
/**
 * 
 *
 * 获取第三方平台自定义的数据字段的同步接口。
 *
 * **Bug & Tip：**
 *
 * 1.  `swan.getExtConfigSync` 暂时无法通过 `swan.canIUse` 判断是否兼容，开发者需要自行判断 `swan.getExtConfigSync` 是否存在来兼容
 *
 * **示例代码：**
 *
 *     ```javascript
 *     let extConfig = swan.getExtConfigSync? swan.getExtConfigSync(): {}
 *     console.log(extConfig)
 *     ```
 * 
 */

exports.getExtConfigSync = getExtConfigSync;

(function (_getExtConfigSync) {})(getExtConfigSync || (exports.getExtConfigSync = getExtConfigSync = {}));

var login;
/**
 * 调用接口swan.login() 获取**临时登录凭证（code）**
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //app.js
 *     App({
 *       onLaunch: function() {
 *         swan.login({
 *           success: function(res) {
 *             if (res.code) {
 *               //发起网络请求
 *               swan.request({
 *                 url: 'https://test.com/onLogin',
 *                 data: {
 *                   code: res.code
 *                 }
 *               })
 *             } else {
 *               console.log('登录失败！' + res.errMsg)
 *             }
 *           }
 *         });
 *       }
 *     })
 *     ```
 * 
 */

exports.login = login;

(function (_login) {})(login || (exports.login = login = {}));

var checkSession;
/**
 * 校验用户当前session_key是否有效。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.checkSession({
 *       success: function(){
 *         //session_key 未过期，并且在本生命周期一直有效
 *       },
 *       fail: function(){
 *         // session_key 已经失效，需要重新执行登录流程
 *         swan.login() //重新登录
 *         ....
 *       }
 *     })
 *     ```
 * 
 */

exports.checkSession = checkSession;

(function (_checkSession) {})(checkSession || (exports.checkSession = checkSession = {}));

var authorize;
/**
 * 
 *
 * 提前向用户发起授权请求。调用后会立刻弹窗询问用户是否同意授权小程序使用某项功能或获取用户的某些数据，但不会实际调用对应接口。如果用户之前已经同意授权，则不会出现弹窗，直接返回成功。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 可以通过 swan.getSetting 先查询一下用户是否授权了 "scope.record" 这个 scope
 *     swan.getSetting({
 *         success(res) {
 *             if (!res.authSetting['scope.record']) {
 *                 swan.authorize({
 *                     scope: 'scope.record',
 *                     success() {
 *                         // 用户已经同意小程序使用录音功能，后续调用 swan.startRecord 接口不会弹窗询问
 *                         swan.startRecord()
 *                     }
 *                 })
 *             }
 *         }
 *     })
 *     ```
 * 
 */

exports.authorize = authorize;

(function (_authorize) {})(authorize || (exports.authorize = authorize = {}));

var getUserInfo;
/**
 * **注意：此接口有调整，使用该接口将不再出现授权弹窗，请使用 <button open-export type="getUserInfo"></button>引导用户主动进行授权操作**
 *
 * 1.  当用户未授权过，调用该接口将直接报错
 * 2.  当用户授权过，可以使用该接口获取用户信息
 *
 * **示例代码：**
 *
 *     ```html
 *     <!--swan-->
 *     <!-- 如果只是展示用户头像昵称，可以使用 <open-data /> 组件 -->
 *     <open-data export type="userAvatarUrl"></open-data>
 *     <open-data export type="userNickName"></open-data>
 *     <!-- 需要使用 button 来授权登录 -->
 *     <button s-if="{{canIUse}}" open-export type="getUserInfo" bindgetuserinfo="bindGetUserInfo">授权登录</button>
 *     <view s-else>请升级手百版本</view>
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     //js
 *     Page({
 *       data: {
 *         canIUse: swan.canIUse('button.open-export type.getUserInfo')
 *       },
 *       onLoad: function() {
 *         // 查看是否授权
 *         swan.getSetting({
 *           success: function(res){
 *             if (res.authSetting['scope.userInfo']) {
 *               // 已经授权，可以直接调用 getUserInfo 获取头像昵称
 *               swan.getUserInfo({
 *                 success: function(res) {
 *                   console(res.userInfo)
 *                 }
 *               })
 *             }
 *           }
 *         })
 *       },
 *       bindGetUserInfo: function(e) {
 *         console.log(e.detail.userInfo)
 *       }
 *     })
 *     ```
 *
 * **示例代码：**
 *
 *     ```json
 *     {
 *         "openId": "OPENID",
 *         "nickName": "NICKNAME",
 *         "gender": GENDER,
 *         "city": "CITY",
 *         "province": "PROVINCE",
 *         "country": "COUNTRY",
 *         "avatarUrl": "AVATARURL",
 *         "unionId": "UNIONID",
 *         "watermark":
 *         {
 *             "appid":"APPID",
 *         "timestamp":TIMESTAMP
 *         }
 *     }
 *     ```
 * 
 */

exports.getUserInfo = getUserInfo;

(function (_getUserInfo) {})(getUserInfo || (exports.getUserInfo = getUserInfo = {}));

var requestPayment;
/**
 * 发起支付。
 *
 * **回调结果：**
 *
 *   回调类型  |  errMsg                                 |  说明                                    
 * ------------|-----------------------------------------|------------------------------------------
 *   success   |  requestPayment:ok                      |  调用支付成功                            
 *   fail      |  requestPayment:fail cancel             |  用户取消支付                            
 *   fail      |  requestPayment:fail (detail message)   |调用支付失败，其中 detail message 为后台返回的详细失败原因
 *
 * **Bug & Tip：**
 *
 * 1.  `bug`: 6.5.2 及之前版本中，用户取消支付不会触发 fail 回调，只会触发 complete 回调，回调 errMsg 为 'requestPayment:cancel'
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.requestPayment({
 *        'timeStamp': '',
 *        'nonceStr': '',
 *        'package': '',
 *        'signType': 'MD5',
 *        'paySign': '',
 *        'success':function(res){
 *        },
 *        'fail':function(res){
 *        }
 *     })
 *     ```
 * 
 */

exports.requestPayment = requestPayment;

(function (_requestPayment) {})(requestPayment || (exports.requestPayment = requestPayment = {}));

var showShareMenu;
/**
 * 
 *
 * 显示当前页面的转发按钮
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.showShareMenu({
 *       withShareTicket: true
 *     })
 *     ```
 * 
 */

exports.showShareMenu = showShareMenu;

(function (_showShareMenu) {})(showShareMenu || (exports.showShareMenu = showShareMenu = {}));

var hideShareMenu;
/**
 * 
 *
 * 隐藏转发按钮
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.hideShareMenu()
 *     ```
 * 
 */

exports.hideShareMenu = hideShareMenu;

(function (_hideShareMenu) {})(hideShareMenu || (exports.hideShareMenu = hideShareMenu = {}));

var updateShareMenu;
/**
 * 
 *
 * 更新转发属性
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.updateShareMenu({
 *       withShareTicket: true,
 *       success() {
 *       }
 *     })
 *     ```
 * 
 */

exports.updateShareMenu = updateShareMenu;

(function (_updateShareMenu) {})(updateShareMenu || (exports.updateShareMenu = updateShareMenu = {}));

var getShareInfo;
/**
 * 
 *
 * 获取转发详细信息
 * 
 */

exports.getShareInfo = getShareInfo;

(function (_getShareInfo) {})(getShareInfo || (exports.getShareInfo = getShareInfo = {}));

var chooseAddress;
/**
 * 
 *
 * 调起用户编辑收货地址原生界面，并在编辑完成后返回用户选择的地址。
 *
 * 需要用户授权scope.address
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseAddress({
 *       success: export function (res) {
 *         console.log(res.userName)
 *         console.log(res.postalCode)
 *         console.log(res.provinceName)
 *         console.log(res.cityName)
 *         console.log(res.countyName)
 *         console.log(res.detailInfo)
 *         console.log(res.nationalCode)
 *         console.log(res.telNumber)
 *       }
 *     })
 *     ```
 * 
 */

exports.chooseAddress = chooseAddress;

(function (_chooseAddress) {})(chooseAddress || (exports.chooseAddress = chooseAddress = {}));

var addCard;
/**
 * 
 *
 * 批量添加卡券。
 *
 * **回调结果：**
 *
 *   回调类型  |  errMsg                          |  说明                                    
 * ------------|----------------------------------|------------------------------------------
 *   success   |  addCard:ok                      |  添加卡券成功                            
 *   fail      |  addCard:fail cancel             |  用户取消添加卡券                        
 *   fail      |  addCard:fail (detail message)   |添加卡券失败，其中 detail message 为后台返回的详细失败原因
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.addCard({
 *       cardList: [
 *         {
 *           cardId: '',
 *           cardExt: '{"code": "", "openid": "", "timestamp": "", "signature":""}'
 *         }, {
 *           cardId: '',
 *           cardExt: '{"code": "", "openid": "", "timestamp": "", "signature":""}'
 *         }
 *       ],
 *       success: function(res) {
 *         console.log(res.cardList) // 卡券添加结果
 *       }
 *     })
 *     ```
 * 
 */

exports.addCard = addCard;

(function (_addCard) {})(addCard || (exports.addCard = addCard = {}));

var openCard;
/**
 * 
 *
 * 查看卡包中的卡券。
 *
 * **Tip：**
 *
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.openCard({
 *       cardList: [
 *         {
 *           cardId: '',
 *           code: ''
 *         }, {
 *           cardId: '',
 *           code: ''
 *         }
 *       ],
 *       success: function(res) {
 *       }
 *     })
 *     ```
 * 
 */

exports.openCard = openCard;

(function (_openCard) {})(openCard || (exports.openCard = openCard = {}));

var openSetting;
/**
 * 
 * > 
 * > 此接口即将废弃，请使用<button>组件来使用此功能
 *
 * 调起客户端小程序设置界面，返回用户设置的操作结果。
 *
 * 注：设置界面只会出现小程序已经向用户请求过的权限。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.openSetting({
 *       success: (res) => {
 *
 *          // res.authSetting = {
 *          //   "scope.userInfo": true,
 *          //   "scope.userLocation": true
 *          // }
 *
 *       }
 *     })
 *     ```
 * 
 */

exports.openSetting = openSetting;

(function (_openSetting) {})(openSetting || (exports.openSetting = openSetting = {}));

var getSetting;
/**
 * 
 *
 * 获取用户的当前设置。
 *
 * 注：返回值中只会出现小程序已经向用户请求过的权限。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getSetting({
 *       success: (res) => {
 *
 *          // res.authSetting = {
 *          //   "scope.userInfo": true,
 *          //   "scope.userLocation": true
 *          // }
 *
 *       }
 *     })
 *     ```
 * 
 */

exports.getSetting = getSetting;

(function (_getSetting) {})(getSetting || (exports.getSetting = getSetting = {}));

var getWeRunData;
/**
 * 
 *
 * 获取用户过去三十天运动步数，需要先调用 swan.login接口。
 *
 * 需要用户授权scope.werun
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.getWeRunData({
 *         success(res) {
 *             const encryptedData = res.encryptedData
 *         }
 *     })
 *     ```
 * 
 */

exports.getWeRunData = getWeRunData;

(function (_getWeRunData) {})(getWeRunData || (exports.getWeRunData = getWeRunData = {}));

var navigateToMiniProgram;
/**
 * 
 * > 
 * > 此接口即将废弃，请使用 <navigator>组件来使用此功能
 *
 * 打开同一公众号下关联的另一个小程序。**（注：必须是同一公众号下，而非同个 open 账号下）**
 *
 * **Bug & Tip：**
 *
 * 1.  `tip`: 在开发者工具上调用此 API 并不会真实的跳转到另外的小程序，但是开发者工具会校验本次调用跳转是否成功
 * 2.  `tip`: 开发者工具上支持被跳转的小程序处理接收参数的调试
 * 3.  `tip`: 只有同一公众号下的关联的小程序之间才可相互跳转 
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.navigateToMiniProgram({
 *       appId: '',
 *       path: 'pages/index/index?id=123',
 *       extraData: {
 *         foo: 'bar'
 *       },
 *       envVersion: 'develop',
 *       success(res) {
 *         // 打开成功
 *       }
 *     })
 *     ```
 * 
 */

exports.navigateToMiniProgram = navigateToMiniProgram;

(function (_navigateToMiniProgram) {})(navigateToMiniProgram || (exports.navigateToMiniProgram = navigateToMiniProgram = {}));

var navigateBackMiniProgram;
/**
 * 
 * > 
 * > iOS 客户端 6.5.9 版本开始支持，Android 客户端即将在 6.5.10 版本开始支持，请先使用 iOS 客户端进行调试
 *
 * 返回到上一个小程序，只有在当前小程序是被其他小程序打开时可以调用成功
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.navigateBackMiniProgram({
 *       extraData: {
 *         foo: 'bar'
 *       },
 *       success(res) {
 *         // 返回成功
 *       }
 *     })
 *     ```
 * 
 */

exports.navigateBackMiniProgram = navigateBackMiniProgram;

(function (_navigateBackMiniProgram) {})(navigateBackMiniProgram || (exports.navigateBackMiniProgram = navigateBackMiniProgram = {}));

var chooseInvoiceTitle;
/**
 * 
 *
 * 选择用户的发票抬头。
 *
 * 需要用户授权scope.invoiceTitle
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.chooseInvoiceTitle({
 *       success(res) {
 *       }
 *     })
 *     ```
 * 
 */

exports.chooseInvoiceTitle = chooseInvoiceTitle;

(function (_chooseInvoiceTitle) {})(chooseInvoiceTitle || (exports.chooseInvoiceTitle = chooseInvoiceTitle = {}));

var checkIsSupportSoterAuthentication;
/**
 * 
 *
 * 获取本机支持的 SOTER 生物认证方式
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.checkIsSupportSoterAuthentication({
 *         success(res) {
 *             // res.supportMode = [] 不具备任何被SOTER支持的生物识别方式
 *             // res.supportMode = ['fingerPrint'] 只支持指纹识别
 *             // res.supportMode = ['fingerPrint', 'facial'] 支持指纹识别和人脸识别
 *         }
 *     })
 *     ```
 * 
 */

exports.checkIsSupportSoterAuthentication = checkIsSupportSoterAuthentication;

(function (_checkIsSupportSoterAuthentication) {})(checkIsSupportSoterAuthentication || (exports.checkIsSupportSoterAuthentication = checkIsSupportSoterAuthentication = {}));

var startSoterAuthentication;
/**
 * 
 *
 * 开始 SOTER 生物认证
 *
 * **生物识别方式定义：**
 *
 *   mode          |  说明         
 * ----------------|---------------
 *   fingerPrint   |  指纹识别     
 *   facial        |人脸识别（暂未支持）
 *   speech        |声纹识别（暂未支持）
 *
 * **resultJSON 说明：**
 *
 *     ```json
 *     {
 *         "raw":"msg",
 *         "fid":"2",
 *         "counter":123,
 *         "tee_n":"TEE Name",
 *         "tee_v":"TEE Version",
 *         "fp_n":"Fingerprint Sensor Name",
 *         "fp_v":"Fingerprint Sensor Version",
 *         "cpu_id":"CPU Id",
 *         "uid":"21"
 *     }
 *     ```
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.startSoterAuthentication({
 *       requestAuthModes: ['fingerPrint'],
 *       challenge: '123456',
 *       authContent: '请用指纹解锁',
 *       success(res) {
 *       }
 *     })
 *     ```
 * 
 */

exports.startSoterAuthentication = startSoterAuthentication;

(function (_startSoterAuthentication) {})(startSoterAuthentication || (exports.startSoterAuthentication = startSoterAuthentication = {}));

var checkIsSoterEnrolledInDevice;
/**
 * 
 *
 * 获取设备内是否录入如指纹等生物信息的接口
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.checkIsSoterEnrolledInDevice({
 *         checkAuthMode: 'fingerPrint',
 *         success(res) {
 *             console.log(res.isEnrolled)
 *         }
 *     })
 *     ```
 * 
 */

exports.checkIsSoterEnrolledInDevice = checkIsSoterEnrolledInDevice;

(function (_checkIsSoterEnrolledInDevice) {})(checkIsSoterEnrolledInDevice || (exports.checkIsSoterEnrolledInDevice = checkIsSoterEnrolledInDevice = {}));

(function (_UpdateManager) {
  var onCheckForUpdate;

  (function (_onCheckForUpdate) {})(onCheckForUpdate || (onCheckForUpdate = _UpdateManager.onCheckForUpdate || (_UpdateManager.onCheckForUpdate = {})));
})(UpdateManager || (exports.UpdateManager = UpdateManager = {}));

var UpdateManager = /*#__PURE__*/(0, _createClass2.default)(function UpdateManager() {
  (0, _classCallCheck2.default)(this, UpdateManager);
});
/**
 * 
 *
 *
 * 创建一个 Worker 线程，并返回 Worker 实例，目前限制最多只能创建一个 Worker，创建下一个 Worker 前请调用 Worker.terminate。
 *
 * `scriptPath` 为 worker 的入口文件路径，需填写绝对路径。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const worker = swan.createWorker('workers/request/index.js') // 文件名指定 worker 的入口文件路径，绝对路径
 *
 *     worker.onMessage(export function (res) {
 *       console.log(res)
 *     })
 *
 *     worker.postMessage({
 *       msg: 'hello worker'
 *     })
 *
 *     worker.terminate()
 *     ```
 * 
 */

exports.UpdateManager = UpdateManager;

(function (_Worker) {
  var onMessage;

  (function (_onMessage3) {})(onMessage || (onMessage = _Worker.onMessage || (_Worker.onMessage = {})));
})(Worker || (exports.Worker = Worker = {}));

var Worker = /*#__PURE__*/(0, _createClass2.default)(function Worker() {
  (0, _classCallCheck2.default)(this, Worker);
});
/**
 * 
 *
 * 自定义业务数据监控上报接口。使用前，需要在小程序管理后台-运维中心-性能监控-业务数据监控中新建监控事件，配置监控描述与告警类型。每一个监控事件对应唯一的监控ID，开发者最多可以创建128个监控事件。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     swan.reportMonitor('1', 1)
 *     ```
 * 
 */

exports.Worker = Worker;
var setEnableDebug;
/**
 * 
 *
 * 设置是否打开调试开关，此开关对正式版也能生效。
 *
 * **Tips：**
 *
 * 1.  `tip`: 在正式版打开调试还有一种方法，就是先在开发版或体验版打开调试，再切到正式版就能看到vConsole。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     // 打开调试
 *     swan.setEnableDebug({
 *         enableDebug: true
 *     })
 *
 *     // 关闭调试
 *     swan.setEnableDebug({
 *         enableDebug: false
 *     })
 *     ```
 * 
 */

exports.setEnableDebug = setEnableDebug;

(function (_setEnableDebug) {})(setEnableDebug || (exports.setEnableDebug = setEnableDebug = {}));

/**
 * 
 *
 * 获取日志管理器 `logManager` 对象。logManager提供log、info、warn、debug四个方法写日志到文件，这四个方法接受任意个类型为Object/Array/Number/String的参数，每次调用的参数的总大小不超过100Kb。最多保存5M的日志内容，超过5M后，旧的日志内容会被删除。用户可以通过设置Button组件的`open-export type`为`feedback`来上传打印的日志。用户上传的日志可以通过登录小程序管理后台后进入左侧菜单“客服反馈”页面获取到。
 *
 * 基础库默认会把App、Page的生命周期函数和swan命名空间下的函数调用写入日志。
 *
 * **示例代码：**
 *
 *     ```javascript
 *     const logger = swan.getLogManager()
 *     logger.log({str: 'hello world'}, 'basic log', 100, [1, 2, 3])
 *     logger.info({str: 'hello world'}, 'info log', 100, [1, 2, 3])
 *     logger.debug({str: 'hello world'}, 'debug log', 100, [1, 2, 3])
 *     logger.warn({str: 'hello world'}, 'warn log', 100, [1, 2, 3])
 *     ```
 * 
 */
// export function getLogManager(): LogManager
// export class  LogManager {
//   /**
//    * 写log日志，可以提供任意个参数，每个参数的类型为Object/Array/Number/String，参数p1到pN的内容会写入日志
//    */
//   log(p1 [: any, p2: any, ...: any, pN]: any): any
//   /**
//    * 写info日志，参数同log方法
//    */
//   info(p1 [: any, p2: any, ...: any, pN]: any): any
//   /**
//    * 写warn日志，参数同log方法
//    */
//   warn(p1 [: any, p2: any, ...: any, pN]: any): any
//   /**
//    * 写debug日志，参数同log方法
//    */
//   debug(p1 [: any, p2: any, ...: any, pN]: any): any
// }
(function (_CanvasContext) {
  var draw;

  (function (_draw) {})(draw || (draw = _CanvasContext.draw || (_CanvasContext.draw = {})));
})(CanvasContext || (exports.CanvasContext = CanvasContext = {}));

var CanvasContext = /*#__PURE__*/(0, _createClass2.default)(function CanvasContext() {
  (0, _classCallCheck2.default)(this, CanvasContext);
});
exports.CanvasContext = CanvasContext;
var getBatteryInfo;
/**
 * 获取设备电量。
 */

exports.getBatteryInfo = getBatteryInfo;

(function (_getBatteryInfo) {})(getBatteryInfo || (exports.getBatteryInfo = getBatteryInfo = {}));

var getBatteryInfoSync;
/**
 * getBatteryInfo 的同步版本。
 */

exports.getBatteryInfoSync = getBatteryInfoSync;

(function (_getBatteryInfoSync) {})(getBatteryInfoSync || (exports.getBatteryInfoSync = getBatteryInfoSync = {}));