"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.showToast = exports.showModal = exports.showLoading = exports.registerToastComponent = exports.registerModalComponent = exports.hideToast = exports.hideLoading = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["duration"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Portals = /*#__PURE__*/(0, _createClass2.default)(function Portals(name) {
  var _this = this;

  (0, _classCallCheck2.default)(this, Portals);
  (0, _defineProperty2.default)(this, "registerComponent", function (component) {
    _this.component = component;
  });
  (0, _defineProperty2.default)(this, "new", function (_ref, callback) {
    var duration = _ref.duration,
        rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

    if (!_this.component) {
      throw new Error("`".concat(_this.name, "` component is not registered."));
    }

    _this.destroy();

    document.body.appendChild(_this.container);
    var Target = _this.component;

    var Container = function Container() {
      (0, _react.useEffect)(function () {
        return function () {
          var _this$unmountedCallba;

          (_this$unmountedCallba = _this.unmountedCallback) === null || _this$unmountedCallba === void 0 ? void 0 : _this$unmountedCallba.call(_this);
        };
      }, []);
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(Target, (0, _objectSpread2.default)({}, rest));
    };

    _reactDom.default.render( /*#__PURE__*/(0, _jsxRuntime.jsx)(Container, {}), _this.container, function () {
      callback === null || callback === void 0 ? void 0 : callback();

      if (typeof duration === 'number') {
        setTimeout(function () {
          _this.destroy();
        }, duration);
      }
    });
  });
  (0, _defineProperty2.default)(this, "destroy", function (callback) {
    if (_this.timer) {
      clearTimeout(_this.timer);
    }

    if (_this.container) {
      _reactDom.default.unmountComponentAtNode(_this.container);

      _this.unmountedCallback = callback;
    }
  });
  this.name = name;
  this.container = document.createElement('div');
});
var globalToast = typeof window !== 'undefined' ? new Portals('Toast') : null;
/**
 * 内部方法，注册 Toast 组件
 */

var registerToastComponent = function registerToastComponent(toastComponent) {
  globalToast === null || globalToast === void 0 ? void 0 : globalToast.registerComponent(toastComponent);
};

exports.registerToastComponent = registerToastComponent;

var showToastInternal = function showToastInternal(_ref2) {
  var title = _ref2.title,
      icon = _ref2.icon,
      _ref2$duration = _ref2.duration,
      duration = _ref2$duration === void 0 ? 1500 : _ref2$duration,
      success = _ref2.success,
      fail = _ref2.fail,
      complete = _ref2.complete;

  try {
    globalToast === null || globalToast === void 0 ? void 0 : globalToast.new({
      icon: icon === 'none' ? undefined : icon,
      children: title,
      duration: duration
    }, function () {
      success === null || success === void 0 ? void 0 : success();
      complete === null || complete === void 0 ? void 0 : complete();
    });
  } catch (error) {
    fail === null || fail === void 0 ? void 0 : fail({
      errMsg: error.message
    });
    complete === null || complete === void 0 ? void 0 : complete();
  }
};
/**
 * 显示消息提示框，用以提供成功、警告和错误等反馈信息。
 */


var showToast = (0, _mpromisify.default)(_util.limited.async('showToast', showToastInternal));
exports.showToast = showToast;

var hideToastInternal = function hideToastInternal(_ref3) {
  var success = _ref3.success,
      complete = _ref3.complete;
  globalToast === null || globalToast === void 0 ? void 0 : globalToast.destroy(function () {
    success === null || success === void 0 ? void 0 : success();
    complete === null || complete === void 0 ? void 0 : complete();
  });
};
/**
 * 隐藏消息提示框。
 */


var hideToast = (0, _mpromisify.default)(_util.limited.async('hideToast', hideToastInternal));
exports.hideToast = hideToast;

var showLoadingInternal = function showLoadingInternal(_ref4) {
  var _ref4$title = _ref4.title,
      title = _ref4$title === void 0 ? '正在加载...' : _ref4$title,
      success = _ref4.success,
      complete = _ref4.complete;
  globalToast === null || globalToast === void 0 ? void 0 : globalToast.new({
    icon: 'loading',
    children: title
  }, function () {
    success === null || success === void 0 ? void 0 : success();
    complete === null || complete === void 0 ? void 0 : complete();
  });
};
/**
 * 显示 loading 提示框, 需主动调用 hideLoading 才能关闭提示框。
 */


var showLoading = (0, _mpromisify.default)(_util.limited.async('showLoading', showLoadingInternal));
exports.showLoading = showLoading;

var hideLoadingInternal = function hideLoadingInternal(_ref5) {
  var success = _ref5.success,
      complete = _ref5.complete;
  globalToast === null || globalToast === void 0 ? void 0 : globalToast.destroy(function () {
    success === null || success === void 0 ? void 0 : success();
    complete === null || complete === void 0 ? void 0 : complete();
  });
};
/**
 * 隐藏 loading 提示框。
 */


var hideLoading = (0, _mpromisify.default)(_util.limited.async('hideLoading', hideLoadingInternal));
/**
 * Modal 组件必要的属性
 */

exports.hideLoading = hideLoading;
var globalModal = typeof window !== 'undefined' ? new Portals('Modal') : null;
/**
 * 内部方法，注册 Modal 组件
 */

var registerModalComponent = function registerModalComponent(modalComponent) {
  globalModal === null || globalModal === void 0 ? void 0 : globalModal.registerComponent(modalComponent);
};

exports.registerModalComponent = registerModalComponent;

var showModalInternal = function showModalInternal(_ref6) {
  var title = _ref6.title,
      content = _ref6.content,
      showCancel = _ref6.showCancel,
      cancelText = _ref6.cancelText,
      cancelColor = _ref6.cancelColor,
      confirmText = _ref6.confirmText,
      confirmColor = _ref6.confirmColor,
      success = _ref6.success,
      complete = _ref6.complete;
  globalModal === null || globalModal === void 0 ? void 0 : globalModal.new({
    title: title,
    children: content,
    showCancel: showCancel,
    cancelText: cancelText,
    cancelColor: cancelColor,
    confirmText: confirmText,
    confirmColor: confirmColor,
    onCancel: function onCancel() {
      success === null || success === void 0 ? void 0 : success({
        confirm: false,
        cancel: true
      });
      complete === null || complete === void 0 ? void 0 : complete();
    },
    onConfirm: function onConfirm() {
      success === null || success === void 0 ? void 0 : success({
        confirm: true,
        cancel: false
      });
      complete === null || complete === void 0 ? void 0 : complete();
    }
  });
};
/**
 * 显示模态弹窗。
 */


var showModal = (0, _mpromisify.default)(_util.limited.async('showModal', showModalInternal));
exports.showModal = showModal;