"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pageScrollTo = void 0;

var _mpromisify = _interopRequireDefault(require("mpromisify"));

var _util = require("../_util");

var _raf = _interopRequireDefault(require("../_util/raf"));

var pageScrollToInternal = function pageScrollToInternal(_ref) {
  var scrollTop = _ref.scrollTop,
      _ref$duration = _ref.duration,
      duration = _ref$duration === void 0 ? 300 : _ref$duration,
      success = _ref.success,
      complete = _ref.complete;
  var pageYOffset = window.pageYOffset;
  var startTime = Date.now();

  var frameFunc = function frameFunc() {
    var timestamp = Date.now();
    var time = timestamp - startTime;
    var nextScrollTop = (0, _util.easeInOutCubic)(time > duration ? duration : time, pageYOffset, scrollTop, duration);
    window.scrollTo(window.pageXOffset, nextScrollTop);

    if (time < duration) {
      (0, _raf.default)(frameFunc);
    } else {
      success === null || success === void 0 ? void 0 : success();
      complete === null || complete === void 0 ? void 0 : complete();
    }
  };

  (0, _raf.default)(frameFunc);
};

var pageScrollTo = (0, _mpromisify.default)(_util.limited.async('pageScrollTo', pageScrollToInternal));
exports.pageScrollTo = pageScrollTo;